searchNodes=[{"doc":"StepFlow provide an entire system to manage workflows. It provides different parts: Connection with a database using Ecto to store Workflow status a connection with a message broker to interact with workers a RESTful API to create, list and interact with workflows","ref":"StepFlow.html","title":"StepFlow","type":"module"},{"doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"StepFlow.html#__using__/1","title":"StepFlow.__using__/1","type":"macro"},{"doc":"Helper to include tools in Controllers","ref":"StepFlow.html#controller/0","title":"StepFlow.controller/0","type":"function"},{"doc":"Helper to include tools in Router","ref":"StepFlow.html#router/0","title":"StepFlow.router/0","type":"function"},{"doc":"Helper to include tools in Views","ref":"StepFlow.html#view/0","title":"StepFlow.view/0","type":"function"},{"doc":"Definition of a Common Consumer of RabbitMQ queue. To implement a consumer, defmodule MyModule do use StepFlow.Amqp.CommonConsumer , %{ queue : &quot;name_of_the_rabbit_mq_queue&quot; , exchange &quot;name_of_exchange&quot; , consumer : &amp; MyModule . consume / 4 } def consume ( channel , tag , redelivered , payload ) do ... Basic . ack ( channel , tag ) end end","ref":"StepFlow.Amqp.CommonConsumer.html","title":"StepFlow.Amqp.CommonConsumer","type":"module"},{"doc":"","ref":"StepFlow.Amqp.CommonConsumer.html#create_queues/2","title":"StepFlow.Amqp.CommonConsumer.create_queues/2","type":"function"},{"doc":"","ref":"StepFlow.Amqp.CommonConsumer.html#init_amqp_connection/4","title":"StepFlow.Amqp.CommonConsumer.init_amqp_connection/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.CommonConsumer.html#rabbitmq_connect/5","title":"StepFlow.Amqp.CommonConsumer.rabbitmq_connect/5","type":"function"},{"doc":"","ref":"StepFlow.Amqp.CommonConsumer.html#rabbitmq_disconnect/1","title":"StepFlow.Amqp.CommonConsumer.rabbitmq_disconnect/1","type":"function"},{"doc":"A common emitter to send job orders to workers.","ref":"StepFlow.Amqp.CommonEmitter.html","title":"StepFlow.Amqp.CommonEmitter","type":"module"},{"doc":"Publish a message. Example: StepFlow.Amqp.CommonEmitter . publish_json ( &quot;my_rabbit_mq_queue&quot; , &quot;{ \\&quot; key \\&quot; : \\&quot; value \\&quot; }&quot; )","ref":"StepFlow.Amqp.CommonEmitter.html#publish/4","title":"StepFlow.Amqp.CommonEmitter.publish/4","type":"function"},{"doc":"Publish a message using JSON serialization before send it. Example: StepFlow.Amqp.CommonEmitter . publish_json ( &quot;my_rabbit_mq_queue&quot; , 0 , %{ key : &quot;value&quot; } )","ref":"StepFlow.Amqp.CommonEmitter.html#publish_json/5","title":"StepFlow.Amqp.CommonEmitter.publish_json/5","type":"function"},{"doc":"Consumer of all job with completed status.","ref":"StepFlow.Amqp.CompletedConsumer.html","title":"StepFlow.Amqp.CompletedConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.CompletedConsumer.html#child_spec/1","title":"StepFlow.Amqp.CompletedConsumer.child_spec/1","type":"function"},{"doc":"Consume messages with completed topic, update Job status and continue the workflow.","ref":"StepFlow.Amqp.CompletedConsumer.html#consume/4","title":"StepFlow.Amqp.CompletedConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.CompletedConsumer.html#disconnect/0","title":"StepFlow.Amqp.CompletedConsumer.disconnect/0","type":"function"},{"doc":"Consumer of all job with error status.","ref":"StepFlow.Amqp.ErrorConsumer.html","title":"StepFlow.Amqp.ErrorConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.ErrorConsumer.html#child_spec/1","title":"StepFlow.Amqp.ErrorConsumer.child_spec/1","type":"function"},{"doc":"Consume message with error topic, update Job and send a notification.","ref":"StepFlow.Amqp.ErrorConsumer.html#consume/4","title":"StepFlow.Amqp.ErrorConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.ErrorConsumer.html#disconnect/0","title":"StepFlow.Amqp.ErrorConsumer.disconnect/0","type":"function"},{"doc":"Helpers for AMQP.","ref":"StepFlow.Amqp.Helpers.html","title":"StepFlow.Amqp.Helpers","type":"module"},{"doc":"","ref":"StepFlow.Amqp.Helpers.html#get_amqp_connection_options/0","title":"StepFlow.Amqp.Helpers.get_amqp_connection_options/0","type":"function"},{"doc":"Get AMQP URL from the configuration or environment variables. hostname Setup the hostname of the RabbitMQ service username Setup the username of the RabbitMQ service password Setup the password of the RabbitMQ service port Setup the port of the RabbitMQ service virtual_host Setup the virtual host of the RabbitMQ service Hardcoded example: config :step_flow , StepFlow.Amqp , hostname : &quot;example.com&quot; , port : &quot;5678&quot; , username : &quot;mediacloudai&quot; , password : &quot;mediacloudai&quot; , virtual_host : &quot;media_cloud_ai_dev&quot; Environment getter example: config :step_flow , StepFlow.Amqp , hostname : { :system , &quot;AMQP_HOSTNAME&quot; } , port : { :system , &quot;AMQP_PORT&quot; } , username : { :system , &quot;AMQP_USERNAME&quot; } , password : { :system , &quot;AMQP_PASSWORD&quot; } , virtual_host : { :system , &quot;AMQP_VIRTUAL_HOST&quot; } ,","ref":"StepFlow.Amqp.Helpers.html#get_amqp_connection_url/0","title":"StepFlow.Amqp.Helpers.get_amqp_connection_url/0","type":"function"},{"doc":"Consumer of all progression jobs.","ref":"StepFlow.Amqp.ProgressionConsumer.html","title":"StepFlow.Amqp.ProgressionConsumer","type":"module"},{"doc":"","ref":"StepFlow.Amqp.ProgressionConsumer.html#add_progression/4","title":"StepFlow.Amqp.ProgressionConsumer.add_progression/4","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.ProgressionConsumer.html#child_spec/1","title":"StepFlow.Amqp.ProgressionConsumer.child_spec/1","type":"function"},{"doc":"Consume message with job progression and save it in database.","ref":"StepFlow.Amqp.ProgressionConsumer.html#consume/4","title":"StepFlow.Amqp.ProgressionConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.ProgressionConsumer.html#disconnect/0","title":"StepFlow.Amqp.ProgressionConsumer.disconnect/0","type":"function"},{"doc":"","ref":"StepFlow.Amqp.ProgressionConsumer.html#error_status_check/5","title":"StepFlow.Amqp.ProgressionConsumer.error_status_check/5","type":"function"},{"doc":"Consumer of all job with stopped status.","ref":"StepFlow.Amqp.StoppedConsumer.html","title":"StepFlow.Amqp.StoppedConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.StoppedConsumer.html#child_spec/1","title":"StepFlow.Amqp.StoppedConsumer.child_spec/1","type":"function"},{"doc":"Consume messages with stopped topic, update Job status and continue the workflow.","ref":"StepFlow.Amqp.StoppedConsumer.html#consume/4","title":"StepFlow.Amqp.StoppedConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.StoppedConsumer.html#disconnect/0","title":"StepFlow.Amqp.StoppedConsumer.disconnect/0","type":"function"},{"doc":"Supervisor of Step Flow. It manages AMQP connection to emit and consume messages as well as manages the StepManager to drive workflows.","ref":"StepFlow.Amqp.Supervisor.html","title":"StepFlow.Amqp.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.Supervisor.html#child_spec/1","title":"StepFlow.Amqp.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"StepFlow.Amqp.Supervisor.html#start_children/0","title":"StepFlow.Amqp.Supervisor.start_children/0","type":"function"},{"doc":"","ref":"StepFlow.Amqp.Supervisor.html#stop_children/0","title":"StepFlow.Amqp.Supervisor.stop_children/0","type":"function"},{"doc":"Consumer of all worker creations.","ref":"StepFlow.Amqp.WorkerCreatedConsumer.html","title":"StepFlow.Amqp.WorkerCreatedConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.WorkerCreatedConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerCreatedConsumer.child_spec/1","type":"function"},{"doc":"Consume worker created message.","ref":"StepFlow.Amqp.WorkerCreatedConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerCreatedConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.WorkerCreatedConsumer.html#disconnect/0","title":"StepFlow.Amqp.WorkerCreatedConsumer.disconnect/0","type":"function"},{"doc":"Consumer of Worker Descriptions.","ref":"StepFlow.Amqp.WorkerDiscoveryConsumer.html","title":"StepFlow.Amqp.WorkerDiscoveryConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.WorkerDiscoveryConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerDiscoveryConsumer.child_spec/1","type":"function"},{"doc":"Consume messages, create Worker Definition if it's not already declared.","ref":"StepFlow.Amqp.WorkerDiscoveryConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerDiscoveryConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.WorkerDiscoveryConsumer.html#disconnect/0","title":"StepFlow.Amqp.WorkerDiscoveryConsumer.disconnect/0","type":"function"},{"doc":"Consumer of all worker inits.","ref":"StepFlow.Amqp.WorkerInitializedConsumer.html","title":"StepFlow.Amqp.WorkerInitializedConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.WorkerInitializedConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerInitializedConsumer.child_spec/1","type":"function"},{"doc":"Consume worker initialized message.","ref":"StepFlow.Amqp.WorkerInitializedConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerInitializedConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.WorkerInitializedConsumer.html#disconnect/0","title":"StepFlow.Amqp.WorkerInitializedConsumer.disconnect/0","type":"function"},{"doc":"Consumer of all worker starts.","ref":"StepFlow.Amqp.WorkerStartedConsumer.html","title":"StepFlow.Amqp.WorkerStartedConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.WorkerStartedConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerStartedConsumer.child_spec/1","type":"function"},{"doc":"Consume worker started message.","ref":"StepFlow.Amqp.WorkerStartedConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerStartedConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.WorkerStartedConsumer.html#disconnect/0","title":"StepFlow.Amqp.WorkerStartedConsumer.disconnect/0","type":"function"},{"doc":"Consumer of all worker statuses.","ref":"StepFlow.Amqp.WorkerStatusConsumer.html","title":"StepFlow.Amqp.WorkerStatusConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.WorkerStatusConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerStatusConsumer.child_spec/1","type":"function"},{"doc":"Consume worker status message.","ref":"StepFlow.Amqp.WorkerStatusConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerStatusConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.WorkerStatusConsumer.html#disconnect/0","title":"StepFlow.Amqp.WorkerStatusConsumer.disconnect/0","type":"function"},{"doc":"Consumer of all worker terminations.","ref":"StepFlow.Amqp.WorkerTerminatedConsumer.html","title":"StepFlow.Amqp.WorkerTerminatedConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.WorkerTerminatedConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerTerminatedConsumer.child_spec/1","type":"function"},{"doc":"Consume worker terminated message.","ref":"StepFlow.Amqp.WorkerTerminatedConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerTerminatedConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.WorkerTerminatedConsumer.html#disconnect/0","title":"StepFlow.Amqp.WorkerTerminatedConsumer.disconnect/0","type":"function"},{"doc":"Consumer of all worker updates.","ref":"StepFlow.Amqp.WorkerUpdatedConsumer.html","title":"StepFlow.Amqp.WorkerUpdatedConsumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Amqp.WorkerUpdatedConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerUpdatedConsumer.child_spec/1","type":"function"},{"doc":"Consume worker updated message.","ref":"StepFlow.Amqp.WorkerUpdatedConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerUpdatedConsumer.consume/4","type":"function"},{"doc":"","ref":"StepFlow.Amqp.WorkerUpdatedConsumer.html#disconnect/0","title":"StepFlow.Amqp.WorkerUpdatedConsumer.disconnect/0","type":"function"},{"doc":"","ref":"StepFlow.ArtifactView.html","title":"StepFlow.ArtifactView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.ArtifactView.html#__resource__/0","title":"StepFlow.ArtifactView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.ArtifactView.html#render/2","title":"StepFlow.ArtifactView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.ArtifactView.html#template_not_found/2","title":"StepFlow.ArtifactView.template_not_found/2","type":"function"},{"doc":"The Artifacts context.","ref":"StepFlow.Artifacts.html","title":"StepFlow.Artifacts","type":"module"},{"doc":"Creates an artifact. Examples iex&gt; create_artifact ( %{ field : value } ) { :ok , % Artifact { } } iex&gt; create_artifact ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Artifacts.html#create_artifact/1","title":"StepFlow.Artifacts.create_artifact/1","type":"function"},{"doc":"StepFlow provide an entire system to manage workflows. It provides differents parts: Connection with a database using Ecto to store Workflow status a connection with a message broker to interact with workers a RESTful API to create, list and interact with workflows","ref":"StepFlow.Authorization.html","title":"StepFlow.Authorization","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"StepFlow.Authorization.html#call/2","title":"StepFlow.Authorization.call/2","type":"function"},{"doc":"Check authorization for the connection using the method and the path. It can be configured using: config :step_flow , authorize : [ module : ExBackendWeb.Authorize , get_jobs : [ :user_check , :specific_right_check ] ]","ref":"StepFlow.Authorization.html#check/1","title":"StepFlow.Authorization.check/1","type":"function"},{"doc":"","ref":"StepFlow.Authorization.html#check_metrics_enabled/1","title":"StepFlow.Authorization.check_metrics_enabled/1","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"StepFlow.Authorization.html#init/1","title":"StepFlow.Authorization.init/1","type":"function"},{"doc":"","ref":"StepFlow.ChangesetView.html","title":"StepFlow.ChangesetView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.ChangesetView.html#__resource__/0","title":"StepFlow.ChangesetView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.ChangesetView.html#render/2","title":"StepFlow.ChangesetView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.ChangesetView.html#template_not_found/2","title":"StepFlow.ChangesetView.template_not_found/2","type":"function"},{"doc":"Traverses and translates changeset errors. See Ecto.Changeset.traverse_errors/2 for more details.","ref":"StepFlow.ChangesetView.html#translate_errors/1","title":"StepFlow.ChangesetView.translate_errors/1","type":"function"},{"doc":"The Helper Controller context.","ref":"StepFlow.Controller.Helpers.html","title":"StepFlow.Controller.Helpers","type":"module"},{"doc":"Check whether a user is allowed to use a rightable structure","ref":"StepFlow.Controller.Helpers.html#has_right?/3","title":"StepFlow.Controller.Helpers.has_right?/3","type":"function"},{"doc":"","ref":"StepFlow.DurationStatisticsView.html","title":"StepFlow.DurationStatisticsView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.DurationStatisticsView.html#__resource__/0","title":"StepFlow.DurationStatisticsView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.DurationStatisticsView.html#render/2","title":"StepFlow.DurationStatisticsView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.DurationStatisticsView.html#template_not_found/2","title":"StepFlow.DurationStatisticsView.template_not_found/2","type":"function"},{"doc":"","ref":"StepFlow.DurationsView.html","title":"StepFlow.DurationsView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.DurationsView.html#__resource__/0","title":"StepFlow.DurationsView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.DurationsView.html#render/2","title":"StepFlow.DurationsView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.DurationsView.html#template_not_found/2","title":"StepFlow.DurationsView.template_not_found/2","type":"function"},{"doc":"","ref":"StepFlow.Endpoint.html","title":"StepFlow.Endpoint","type":"module"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast!/3 .","ref":"StepFlow.Endpoint.html#broadcast!/3","title":"StepFlow.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast/3 .","ref":"StepFlow.Endpoint.html#broadcast/3","title":"StepFlow.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from!/4 .","ref":"StepFlow.Endpoint.html#broadcast_from!/4","title":"StepFlow.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from/4 .","ref":"StepFlow.Endpoint.html#broadcast_from/4","title":"StepFlow.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for Plug.call/2 .","ref":"StepFlow.Endpoint.html#call/2","title":"StepFlow.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint under a supervision tree.","ref":"StepFlow.Endpoint.html#child_spec/1","title":"StepFlow.Endpoint.child_spec/1","type":"function"},{"doc":"Returns the endpoint configuration for key Returns default if the key does not exist.","ref":"StepFlow.Endpoint.html#config/2","title":"StepFlow.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"StepFlow.Endpoint.html#config_change/2","title":"StepFlow.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"StepFlow.Endpoint.html#host/0","title":"StepFlow.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"StepFlow.Endpoint.html#init/1","title":"StepFlow.Endpoint.init/1","type":"function"},{"doc":"Callback invoked for dynamically configuring the endpoint. It receives the endpoint configuration and checks if configuration should be loaded from the system environment.","ref":"StepFlow.Endpoint.html#init/2","title":"StepFlow.Endpoint.init/2","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast/3 .","ref":"StepFlow.Endpoint.html#local_broadcast/3","title":"StepFlow.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast_from/4 .","ref":"StepFlow.Endpoint.html#local_broadcast_from/4","title":"StepFlow.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"StepFlow.Endpoint.html#path/1","title":"StepFlow.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"StepFlow.Endpoint.html#script_name/0","title":"StepFlow.Endpoint.script_name/0","type":"function"},{"doc":"Starts the endpoint supervision tree. Options :log_access_url - if the access url should be logged once the endpoint starts All other options are merged into the endpoint configuration.","ref":"StepFlow.Endpoint.html#start_link/1","title":"StepFlow.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file in priv/static . Meant to be used for Subresource Integrity with CDNs.","ref":"StepFlow.Endpoint.html#static_integrity/1","title":"StepFlow.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the static_path and the second item being the static_integrity .","ref":"StepFlow.Endpoint.html#static_lookup/1","title":"StepFlow.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in priv/static .","ref":"StepFlow.Endpoint.html#static_path/1","title":"StepFlow.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information. It uses the configuration under :static_url to generate such. It falls back to :url if :static_url is not set.","ref":"StepFlow.Endpoint.html#static_url/0","title":"StepFlow.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a URI struct. It uses the configuration under :url to generate such. Useful for manipulating the URL data and passing it to URL helpers.","ref":"StepFlow.Endpoint.html#struct_url/0","title":"StepFlow.Endpoint.struct_url/0","type":"function"},{"doc":"","ref":"StepFlow.Endpoint.html#subscribe/2","title":"StepFlow.Endpoint.subscribe/2","type":"function"},{"doc":"","ref":"StepFlow.Endpoint.html#unsubscribe/1","title":"StepFlow.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information. It uses the configuration under :url to generate such.","ref":"StepFlow.Endpoint.html#url/0","title":"StepFlow.Endpoint.url/0","type":"function"},{"doc":"Conveniences for translating and building error messages.","ref":"StepFlow.ErrorHelpers.html","title":"StepFlow.ErrorHelpers","type":"module"},{"doc":"Generates tag for inlined form input errors.","ref":"StepFlow.ErrorHelpers.html#error_tag/2","title":"StepFlow.ErrorHelpers.error_tag/2","type":"function"},{"doc":"Translates an error message using gettext.","ref":"StepFlow.ErrorHelpers.html#translate_error/1","title":"StepFlow.ErrorHelpers.translate_error/1","type":"function"},{"doc":"","ref":"StepFlow.ErrorView.html","title":"StepFlow.ErrorView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.ErrorView.html#__resource__/0","title":"StepFlow.ErrorView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.ErrorView.html#render/2","title":"StepFlow.ErrorView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.ErrorView.html#template_not_found/2","title":"StepFlow.ErrorView.template_not_found/2","type":"function"},{"doc":"Translates controller action results into valid Plug.Conn responses. See Phoenix.Controller.action_fallback/1 for more details.","ref":"StepFlow.FallbackController.html","title":"StepFlow.FallbackController","type":"module"},{"doc":"A module providing Internationalization with a gettext-based API. By using Gettext , your module gains a set of macros for translations, for example: import StepFlow.Gettext # Simple translation gettext &quot;Here is the string to translate&quot; # Plural translation ngettext &quot;Here is the string to translate&quot; , &quot;Here are the strings to translate&quot; , 3 # Domain-based translation dgettext &quot;errors&quot; , &quot;Here is the error message to translate&quot; See the Gettext Docs for detailed usage.","ref":"StepFlow.Gettext.html","title":"StepFlow.Gettext","type":"module"},{"doc":"Callback implementation for Gettext.Backend.dgettext/3 .","ref":"StepFlow.Gettext.html#dgettext/3","title":"StepFlow.Gettext.dgettext/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext_noop/2 .","ref":"StepFlow.Gettext.html#dgettext_noop/2","title":"StepFlow.Gettext.dgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext/5 .","ref":"StepFlow.Gettext.html#dngettext/5","title":"StepFlow.Gettext.dngettext/5","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext_noop/3 .","ref":"StepFlow.Gettext.html#dngettext_noop/3","title":"StepFlow.Gettext.dngettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpgettext/4 .","ref":"StepFlow.Gettext.html#dpgettext/4","title":"StepFlow.Gettext.dpgettext/4","type":"macro"},{"doc":"","ref":"StepFlow.Gettext.html#dpgettext_noop/3","title":"StepFlow.Gettext.dpgettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpngettext/6 .","ref":"StepFlow.Gettext.html#dpngettext/6","title":"StepFlow.Gettext.dpngettext/6","type":"macro"},{"doc":"","ref":"StepFlow.Gettext.html#dpngettext_noop/4","title":"StepFlow.Gettext.dpngettext_noop/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext/2 .","ref":"StepFlow.Gettext.html#gettext/2","title":"StepFlow.Gettext.gettext/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_comment/1 .","ref":"StepFlow.Gettext.html#gettext_comment/1","title":"StepFlow.Gettext.gettext_comment/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_noop/1 .","ref":"StepFlow.Gettext.html#gettext_noop/1","title":"StepFlow.Gettext.gettext_noop/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2 .","ref":"StepFlow.Gettext.html#handle_missing_bindings/2","title":"StepFlow.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/6 .","ref":"StepFlow.Gettext.html#handle_missing_plural_translation/6","title":"StepFlow.Gettext.handle_missing_plural_translation/6","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_translation/4 .","ref":"StepFlow.Gettext.html#handle_missing_translation/4","title":"StepFlow.Gettext.handle_missing_translation/4","type":"function"},{"doc":"","ref":"StepFlow.Gettext.html#lgettext/5","title":"StepFlow.Gettext.lgettext/5","type":"function"},{"doc":"","ref":"StepFlow.Gettext.html#lngettext/7","title":"StepFlow.Gettext.lngettext/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.ngettext/4 .","ref":"StepFlow.Gettext.html#ngettext/4","title":"StepFlow.Gettext.ngettext/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.ngettext_noop/2 .","ref":"StepFlow.Gettext.html#ngettext_noop/2","title":"StepFlow.Gettext.ngettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pgettext/3 .","ref":"StepFlow.Gettext.html#pgettext/3","title":"StepFlow.Gettext.pgettext/3","type":"macro"},{"doc":"","ref":"StepFlow.Gettext.html#pgettext_noop/2","title":"StepFlow.Gettext.pgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pngettext/5 .","ref":"StepFlow.Gettext.html#pngettext/5","title":"StepFlow.Gettext.pngettext/5","type":"macro"},{"doc":"","ref":"StepFlow.Gettext.html#pngettext_noop/3","title":"StepFlow.Gettext.pngettext_noop/3","type":"macro"},{"doc":"","ref":"StepFlow.IndexController.html","title":"StepFlow.IndexController","type":"module"},{"doc":"","ref":"StepFlow.IndexController.html#index/2","title":"StepFlow.IndexController.index/2","type":"function"},{"doc":"","ref":"StepFlow.IndexController.html#not_found/2","title":"StepFlow.IndexController.not_found/2","type":"function"},{"doc":"","ref":"StepFlow.IndexController.html#swagger_path_index/1","title":"StepFlow.IndexController.swagger_path_index/1","type":"function"},{"doc":"","ref":"StepFlow.JobController.html","title":"StepFlow.JobController","type":"module"},{"doc":"","ref":"StepFlow.JobController.html#index/2","title":"StepFlow.JobController.index/2","type":"function"},{"doc":"","ref":"StepFlow.JobController.html#show/2","title":"StepFlow.JobController.show/2","type":"function"},{"doc":"","ref":"StepFlow.JobView.html","title":"StepFlow.JobView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.JobView.html#__resource__/0","title":"StepFlow.JobView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.JobView.html#render/2","title":"StepFlow.JobView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.JobView.html#template_not_found/2","title":"StepFlow.JobView.template_not_found/2","type":"function"},{"doc":"The Jobs context.","ref":"StepFlow.Jobs.html","title":"StepFlow.Jobs","type":"module"},{"doc":"","ref":"StepFlow.Jobs.html#abort_jobs/3","title":"StepFlow.Jobs.abort_jobs/3","type":"function"},{"doc":"","ref":"StepFlow.Jobs.html#apply_default_query_filters/2","title":"StepFlow.Jobs.apply_default_query_filters/2","type":"function"},{"doc":"","ref":"StepFlow.Jobs.html#apply_rights/2","title":"StepFlow.Jobs.apply_rights/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking job changes. Examples iex&gt; change_job ( job ) % Ecto.Changeset { source : % Job { } }","ref":"StepFlow.Jobs.html#change_job/1","title":"StepFlow.Jobs.change_job/1","type":"function"},{"doc":"Creates a job with a completed status. Examples iex&gt; create_completed_job ( workflow , step_id , &quot;webhook_notification&quot; ) { :ok , &quot;completed&quot; }","ref":"StepFlow.Jobs.html#create_completed_job/3","title":"StepFlow.Jobs.create_completed_job/3","type":"function"},{"doc":"Creates a job with an error status. Examples iex&gt; create_error_job ( workflow , step_id , &quot;download_http&quot; , &quot;unsupported step&quot; ) { :ok , &quot;created&quot; }","ref":"StepFlow.Jobs.html#create_error_job/4","title":"StepFlow.Jobs.create_error_job/4","type":"function"},{"doc":"Creates a job. Examples iex&gt; create_job ( %{ field : value } ) { :ok , % Job { } } iex&gt; create_job ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Jobs.html#create_job/1","title":"StepFlow.Jobs.create_job/1","type":"function"},{"doc":"Creates a job with a paused status. Examples iex&gt; create_paused_job ( workflow , 1 , &quot;download_http&quot; ) { :ok , &quot;paused&quot; }","ref":"StepFlow.Jobs.html#create_paused_job/4","title":"StepFlow.Jobs.create_paused_job/4","type":"function"},{"doc":"Creates a job with a skipped status. Examples iex&gt; create_skipped_job ( workflow , 1 , &quot;download_http&quot; ) { :ok , &quot;skipped&quot; }","ref":"StepFlow.Jobs.html#create_skipped_job/3","title":"StepFlow.Jobs.create_skipped_job/3","type":"function"},{"doc":"Deletes a Job. Examples iex&gt; delete_job ( job ) { :ok , % Job { } } iex&gt; delete_job ( job ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Jobs.html#delete_job/1","title":"StepFlow.Jobs.delete_job/1","type":"function"},{"doc":"","ref":"StepFlow.Jobs.html#filter_status/2","title":"StepFlow.Jobs.filter_status/2","type":"function"},{"doc":"","ref":"StepFlow.Jobs.html#filter_worker_instance_id/2","title":"StepFlow.Jobs.filter_worker_instance_id/2","type":"function"},{"doc":"","ref":"StepFlow.Jobs.html#filter_worker_label/2","title":"StepFlow.Jobs.filter_worker_label/2","type":"function"},{"doc":"","ref":"StepFlow.Jobs.html#filter_worker_version/2","title":"StepFlow.Jobs.filter_worker_version/2","type":"function"},{"doc":"Gets a single job by workflow ID and step ID Examples iex&gt; get_job ( 123 ) % Job { } iex&gt; get_job ( 456 ) nil","ref":"StepFlow.Jobs.html#get_by!/1","title":"StepFlow.Jobs.get_by!/1","type":"function"},{"doc":"Gets a single job by workflow ID and step ID Examples iex&gt; get_job ( 123 ) % Job { } iex&gt; get_job ( 456 ) nil","ref":"StepFlow.Jobs.html#get_by/1","title":"StepFlow.Jobs.get_by/1","type":"function"},{"doc":"Gets a single job. Raises Ecto.NoResultsError if the Job does not exist. Examples iex&gt; get_job! ( 123 ) % Job { } iex&gt; get_job! ( 456 ) ** (Ecto.NoResultsError)","ref":"StepFlow.Jobs.html#get_job!/1","title":"StepFlow.Jobs.get_job!/1","type":"function"},{"doc":"Gets a single job. Examples iex&gt; get_job ( 123 ) % Job { } iex&gt; get_job ( 456 ) nil","ref":"StepFlow.Jobs.html#get_job/1","title":"StepFlow.Jobs.get_job/1","type":"function"},{"doc":"Gets a single job with its related status. Raises Ecto.NoResultsError if the Job does not exist. Examples iex&gt; get_job_with_status! ( 123 ) % Job { } iex&gt; get_job! ( 456 ) ** (Ecto.NoResultsError)","ref":"StepFlow.Jobs.html#get_job_with_status!/1","title":"StepFlow.Jobs.get_job_with_status!/1","type":"function"},{"doc":"Returns a formatted message for AMQP orders. Examples iex&gt; get_message ( job ) %{ job_id : 123 , parameters : [ { id : &quot;input&quot; , type : &quot;string&quot; , value : &quot;/path/to/input&quot; } ] }","ref":"StepFlow.Jobs.html#get_message/1","title":"StepFlow.Jobs.get_message/1","type":"function"},{"doc":"Returns the list of jobs pending&quot;","ref":"StepFlow.Jobs.html#get_pending_jobs_by_type/0","title":"StepFlow.Jobs.get_pending_jobs_by_type/0","type":"function"},{"doc":"","ref":"StepFlow.Jobs.html#internal_list_jobs/1","title":"StepFlow.Jobs.internal_list_jobs/1","type":"function"},{"doc":"Returns the list of jobs. Examples iex&gt; list_jobs ( ) [ % Job { } , ... ]","ref":"StepFlow.Jobs.html#list_jobs/1","title":"StepFlow.Jobs.list_jobs/1","type":"function"},{"doc":"Set skipped status to all queued jobs. Examples iex&gt; skip_jobs ( workflow , step_id , &quot;download_http&quot; ) :ok","ref":"StepFlow.Jobs.html#skip_jobs/3","title":"StepFlow.Jobs.skip_jobs/3","type":"function"},{"doc":"Updates a job. Examples iex&gt; update_job ( job , %{ field : new_value } ) { :ok , % Job { } } iex&gt; update_job ( job , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Jobs.html#update_job/2","title":"StepFlow.Jobs.update_job/2","type":"function"},{"doc":"","ref":"StepFlow.Jobs.Status.StateEnum.html","title":"StepFlow.Jobs.Status.StateEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"StepFlow.Jobs.Status.StateEnum.html#cast/1","title":"StepFlow.Jobs.Status.StateEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"StepFlow.Jobs.Status.StateEnum.html#dump/1","title":"StepFlow.Jobs.Status.StateEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"StepFlow.Jobs.Status.StateEnum.html#embed_as/1","title":"StepFlow.Jobs.Status.StateEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"StepFlow.Jobs.Status.StateEnum.html#equal?/2","title":"StepFlow.Jobs.Status.StateEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"StepFlow.Jobs.Status.StateEnum.html#load/1","title":"StepFlow.Jobs.Status.StateEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"StepFlow.Jobs.Status.StateEnum.html#type/0","title":"StepFlow.Jobs.Status.StateEnum.type/0","type":"function"},{"doc":"","ref":"StepFlow.Jobs.Status.StateEnum.html#valid_value?/1","title":"StepFlow.Jobs.Status.StateEnum.valid_value?/1","type":"function"},{"doc":"","ref":"StepFlow.Jobs.Status.StateEnum.html#t:t/0","title":"StepFlow.Jobs.Status.StateEnum.t/0","type":"type"},{"doc":"The LiveWorkers context.","ref":"StepFlow.LiveWorkers.html","title":"StepFlow.LiveWorkers","type":"module"},{"doc":"Returns an %Ecto.Changeset{} for tracking live worker changes. Examples iex&gt; change_live_worker ( job ) % Ecto.Changeset { source : % LiveWorker { } }","ref":"StepFlow.LiveWorkers.html#change_live_worker/1","title":"StepFlow.LiveWorkers.change_live_worker/1","type":"function"},{"doc":"Creates a Live Worker entry. Examples iex&gt; create_live_worker ( %{ field : value } ) { :ok , % LiveWorker { } } iex&gt; create_live_worker ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.LiveWorkers.html#create_live_worker/1","title":"StepFlow.LiveWorkers.create_live_worker/1","type":"function"},{"doc":"Deletes a LiveWorker. Examples iex&gt; delete_live_worker ( live_worker ) { :ok , % LiveWorker { } } iex&gt; delete_live_worker ( live_worker ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.LiveWorkers.html#delete_live_worker/1","title":"StepFlow.LiveWorkers.delete_live_worker/1","type":"function"},{"doc":"Gets a single live worker by job ID Examples iex&gt; get_by! ( 123 ) % LiveWorker { } iex&gt; get_by! ( 456 ) nil","ref":"StepFlow.LiveWorkers.html#get_by!/1","title":"StepFlow.LiveWorkers.get_by!/1","type":"function"},{"doc":"Gets a single live worker by job ID Examples iex&gt; get_by ( %{ &quot;job_id&quot; =&gt; 123 } ) % LiveWorker { } iex&gt; get_by ( %{ &quot;job_id&quot; =&gt; 456 } ) nil","ref":"StepFlow.LiveWorkers.html#get_by/1","title":"StepFlow.LiveWorkers.get_by/1","type":"function"},{"doc":"Returns the list of Live Worker. Examples iex&gt; StepFlow.LiveWorkers . list_live_workers ( ) %{ data : [ ] , page : 0 , size : 10 , total : 0 }","ref":"StepFlow.LiveWorkers.html#list_live_workers/1","title":"StepFlow.LiveWorkers.list_live_workers/1","type":"function"},{"doc":"Updates a live worker. Examples iex&gt; update_live_worker ( job , %{ field : new_value } ) { :ok , % LiveWorker { } } iex&gt; update_live_worker ( job , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.LiveWorkers.html#update_live_worker/2","title":"StepFlow.LiveWorkers.update_live_worker/2","type":"function"},{"doc":"","ref":"StepFlow.LiveWorkersController.html","title":"StepFlow.LiveWorkersController","type":"module"},{"doc":"","ref":"StepFlow.LiveWorkersController.html#index/2","title":"StepFlow.LiveWorkersController.index/2","type":"function"},{"doc":"","ref":"StepFlow.LiveWorkersView.html","title":"StepFlow.LiveWorkersView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.LiveWorkersView.html#__resource__/0","title":"StepFlow.LiveWorkersView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.LiveWorkersView.html#render/2","title":"StepFlow.LiveWorkersView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.LiveWorkersView.html#template_not_found/2","title":"StepFlow.LiveWorkersView.template_not_found/2","type":"function"},{"doc":"Extend Map with some additional functions.","ref":"StepFlow.Map.html","title":"StepFlow.Map","type":"module"},{"doc":"Get a key matching on an atom or a string. Default value can be specified. Examples iex&gt; StepFlow.Map . get_by_key_or_atom ( %{ key : &quot;value&quot; } , :key ) &quot;value&quot; iex&gt; StepFlow.Map . get_by_key_or_atom ( %{ &quot;key&quot; =&gt; &quot;value&quot; } , :key ) &quot;value&quot; iex&gt; StepFlow.Map . get_by_key_or_atom ( %{ key : &quot;value&quot; } , &quot;key&quot; ) &quot;value&quot; iex&gt; StepFlow.Map . get_by_key_or_atom ( %{ &quot;key&quot; =&gt; &quot;value&quot; } , &quot;key&quot; ) &quot;value&quot;","ref":"StepFlow.Map.html#get_by_key_or_atom/3","title":"StepFlow.Map.get_by_key_or_atom/3","type":"function"},{"doc":"Replace an item in a map, with atom or string keys. Examples iex&gt; StepFlow.Map . replace_by_atom ( %{ key : &quot;value&quot; } , :key , &quot;replaced_value&quot; ) %{ key : &quot;replaced_value&quot; } iex&gt; StepFlow.Map . replace_by_atom ( %{ &quot;key&quot; =&gt; &quot;value&quot; } , :key , &quot;replaced_value&quot; ) %{ key : &quot;replaced_value&quot; } iex&gt; StepFlow.Map . replace_by_atom ( %{ &quot;key&quot; =&gt; &quot;value&quot; } , &quot;key&quot; , &quot;replaced_value&quot; ) %{ key : &quot;replaced_value&quot; }","ref":"StepFlow.Map.html#replace_by_atom/3","title":"StepFlow.Map.replace_by_atom/3","type":"function"},{"doc":"","ref":"StepFlow.Map.html#replace_by_string/3","title":"StepFlow.Map.replace_by_string/3","type":"function"},{"doc":"Prometheus metrics instrumenter to call jobs metric collectors","ref":"StepFlow.Metrics.JobInstrumenter.html","title":"StepFlow.Metrics.JobInstrumenter","type":"module"},{"doc":"","ref":"StepFlow.Metrics.JobInstrumenter.html#inc/2","title":"StepFlow.Metrics.JobInstrumenter.inc/2","type":"function"},{"doc":"","ref":"StepFlow.Metrics.JobInstrumenter.html#setup/0","title":"StepFlow.Metrics.JobInstrumenter.setup/0","type":"function"},{"doc":"Prometheus metrics collector for pending jobs","ref":"StepFlow.Metrics.JobsPendingCollector.html","title":"StepFlow.Metrics.JobsPendingCollector","type":"module"},{"doc":"","ref":"StepFlow.Metrics.JobsPendingCollector.html#collect_metrics/2","title":"StepFlow.Metrics.JobsPendingCollector.collect_metrics/2","type":"function"},{"doc":"Callback implementation for :prometheus_collector.collect_mf/2 .","ref":"StepFlow.Metrics.JobsPendingCollector.html#collect_mf/2","title":"StepFlow.Metrics.JobsPendingCollector.collect_mf/2","type":"function"},{"doc":"Callback implementation for :prometheus_collector.deregister_cleanup/1 .","ref":"StepFlow.Metrics.JobsPendingCollector.html#deregister_cleanup/1","title":"StepFlow.Metrics.JobsPendingCollector.deregister_cleanup/1","type":"function"},{"doc":"Prometheus metrics collector for workflow duration","ref":"StepFlow.Metrics.WorkflowCollector.html","title":"StepFlow.Metrics.WorkflowCollector","type":"module"},{"doc":"","ref":"StepFlow.Metrics.WorkflowCollector.html#collect_metrics/2","title":"StepFlow.Metrics.WorkflowCollector.collect_metrics/2","type":"function"},{"doc":"Callback implementation for :prometheus_collector.collect_mf/2 .","ref":"StepFlow.Metrics.WorkflowCollector.html#collect_mf/2","title":"StepFlow.Metrics.WorkflowCollector.collect_mf/2","type":"function"},{"doc":"Callback implementation for :prometheus_collector.deregister_cleanup/1 .","ref":"StepFlow.Metrics.WorkflowCollector.html#deregister_cleanup/1","title":"StepFlow.Metrics.WorkflowCollector.deregister_cleanup/1","type":"function"},{"doc":"Prometheus metrics instrumenter to call workflow metric collectors","ref":"StepFlow.Metrics.WorkflowInstrumenter.html","title":"StepFlow.Metrics.WorkflowInstrumenter","type":"module"},{"doc":"","ref":"StepFlow.Metrics.WorkflowInstrumenter.html#inc/2","title":"StepFlow.Metrics.WorkflowInstrumenter.inc/2","type":"function"},{"doc":"","ref":"StepFlow.Metrics.WorkflowInstrumenter.html#setup/0","title":"StepFlow.Metrics.WorkflowInstrumenter.setup/0","type":"function"},{"doc":"Send notifications to endpoint to be forwarded to websockets.","ref":"StepFlow.Notification.html","title":"StepFlow.Notification","type":"module"},{"doc":"","ref":"StepFlow.Notification.html#send/2","title":"StepFlow.Notification.send/2","type":"function"},{"doc":"Notification implementation with various services. WebHook to make HTTP call to external APIs Slack to post a message on a channel","ref":"StepFlow.Notifications.Notification.html","title":"StepFlow.Notifications.Notification","type":"module"},{"doc":"","ref":"StepFlow.Notifications.Notification.html#process/6","title":"StepFlow.Notifications.Notification.process/6","type":"function"},{"doc":"Notification step implementation to send messages on Slack channel.","ref":"StepFlow.Notifications.Slack.html","title":"StepFlow.Notifications.Slack","type":"module"},{"doc":"","ref":"StepFlow.Notifications.Slack.html#process/6","title":"StepFlow.Notifications.Slack.process/6","type":"function"},{"doc":"Notification step implementation to send HTTP call to Teams channel.","ref":"StepFlow.Notifications.Teams.html","title":"StepFlow.Notifications.Teams","type":"module"},{"doc":"","ref":"StepFlow.Notifications.Teams.html#get_headers/4","title":"StepFlow.Notifications.Teams.get_headers/4","type":"function"},{"doc":"","ref":"StepFlow.Notifications.Teams.html#process/6","title":"StepFlow.Notifications.Teams.process/6","type":"function"},{"doc":"Notification step implementation to send HTTP call.","ref":"StepFlow.Notifications.WebHook.html","title":"StepFlow.Notifications.WebHook","type":"module"},{"doc":"","ref":"StepFlow.Notifications.WebHook.html#get_headers/4","title":"StepFlow.Notifications.WebHook.get_headers/4","type":"function"},{"doc":"","ref":"StepFlow.Notifications.WebHook.html#process/6","title":"StepFlow.Notifications.WebHook.process/6","type":"function"},{"doc":"The Progressions context.","ref":"StepFlow.Progressions.html","title":"StepFlow.Progressions","type":"module"},{"doc":"Creates a progression. Examples iex&gt; create_progression ( %{ field : value } ) { :ok , % Progression { } } iex&gt; create_progression ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Progressions.html#create_progression/1","title":"StepFlow.Progressions.create_progression/1","type":"function"},{"doc":"","ref":"StepFlow.ProgressionsView.html","title":"StepFlow.ProgressionsView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.ProgressionsView.html#__resource__/0","title":"StepFlow.ProgressionsView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.ProgressionsView.html#render/2","title":"StepFlow.ProgressionsView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.ProgressionsView.html#template_not_found/2","title":"StepFlow.ProgressionsView.template_not_found/2","type":"function"},{"doc":"","ref":"StepFlow.Repo.html","title":"StepFlow.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/3 .","ref":"StepFlow.Repo.html#aggregate/3","title":"StepFlow.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"StepFlow.Repo.html#aggregate/4","title":"StepFlow.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"StepFlow.Repo.html#all/2","title":"StepFlow.Repo.all/2","type":"function"},{"doc":"","ref":"StepFlow.Repo.html#bypass/1","title":"StepFlow.Repo.bypass/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checked_out?/0 .","ref":"StepFlow.Repo.html#checked_out?/0","title":"StepFlow.Repo.checked_out?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checkout/2 .","ref":"StepFlow.Repo.html#checkout/2","title":"StepFlow.Repo.checkout/2","type":"function"},{"doc":"","ref":"StepFlow.Repo.html#child_spec/1","title":"StepFlow.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"StepFlow.Repo.html#config/0","title":"StepFlow.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.default_options/1 .","ref":"StepFlow.Repo.html#default_options/1","title":"StepFlow.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"StepFlow.Repo.html#delete!/2","title":"StepFlow.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"StepFlow.Repo.html#delete/2","title":"StepFlow.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"StepFlow.Repo.html#delete_all/2","title":"StepFlow.Repo.delete_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.exists?/2 .","ref":"StepFlow.Repo.html#exists?/2","title":"StepFlow.Repo.exists?/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query. See Ecto.Adapters.SQL.explain/4 for more information.","ref":"StepFlow.Repo.html#explain/3","title":"StepFlow.Repo.explain/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"StepFlow.Repo.html#get!/3","title":"StepFlow.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"StepFlow.Repo.html#get/3","title":"StepFlow.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"StepFlow.Repo.html#get_by!/3","title":"StepFlow.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"StepFlow.Repo.html#get_by/3","title":"StepFlow.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0 .","ref":"StepFlow.Repo.html#get_dynamic_repo/0","title":"StepFlow.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"StepFlow.Repo.html#in_transaction?/0","title":"StepFlow.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.init/2 .","ref":"StepFlow.Repo.html#init/2","title":"StepFlow.Repo.init/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"StepFlow.Repo.html#insert!/2","title":"StepFlow.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"StepFlow.Repo.html#insert/2","title":"StepFlow.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"StepFlow.Repo.html#insert_all/3","title":"StepFlow.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"StepFlow.Repo.html#insert_or_update!/2","title":"StepFlow.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"StepFlow.Repo.html#insert_or_update/2","title":"StepFlow.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"StepFlow.Repo.html#load/2","title":"StepFlow.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"StepFlow.Repo.html#one!/2","title":"StepFlow.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"StepFlow.Repo.html#one/2","title":"StepFlow.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"StepFlow.Repo.html#preload/3","title":"StepFlow.Repo.preload/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.prepare_query/3 .","ref":"StepFlow.Repo.html#prepare_query/3","title":"StepFlow.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1 .","ref":"StepFlow.Repo.html#put_dynamic_repo/1","title":"StepFlow.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"StepFlow.Repo.html#query!/3","title":"StepFlow.Repo.query!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"StepFlow.Repo.html#query/3","title":"StepFlow.Repo.query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload!/2 .","ref":"StepFlow.Repo.html#reload!/2","title":"StepFlow.Repo.reload!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload/2 .","ref":"StepFlow.Repo.html#reload/2","title":"StepFlow.Repo.reload/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"StepFlow.Repo.html#rollback/1","title":"StepFlow.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"StepFlow.Repo.html#start_link/1","title":"StepFlow.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/1 .","ref":"StepFlow.Repo.html#stop/1","title":"StepFlow.Repo.stop/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"StepFlow.Repo.html#stream/2","title":"StepFlow.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"StepFlow.Repo.html#to_sql/2","title":"StepFlow.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"StepFlow.Repo.html#transaction/2","title":"StepFlow.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"StepFlow.Repo.html#update!/2","title":"StepFlow.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"StepFlow.Repo.html#update/2","title":"StepFlow.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"StepFlow.Repo.html#update_all/3","title":"StepFlow.Repo.update_all/3","type":"function"},{"doc":"Dump the application supervision tree into the application logs. Useful for debugging purpose.","ref":"StepFlow.Repo.SupervisionTree.html","title":"StepFlow.Repo.SupervisionTree","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Repo.SupervisionTree.html#child_spec/1","title":"StepFlow.Repo.SupervisionTree.child_spec/1","type":"function"},{"doc":"","ref":"StepFlow.Repo.SupervisionTree.html#start_link/0","title":"StepFlow.Repo.SupervisionTree.start_link/0","type":"function"},{"doc":"","ref":"StepFlow.RightDefinitionController.html","title":"StepFlow.RightDefinitionController","type":"module"},{"doc":"","ref":"StepFlow.RightDefinitionController.html#index/2","title":"StepFlow.RightDefinitionController.index/2","type":"function"},{"doc":"","ref":"StepFlow.RightDefinitionView.html","title":"StepFlow.RightDefinitionView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.RightDefinitionView.html#__resource__/0","title":"StepFlow.RightDefinitionView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.RightDefinitionView.html#render/2","title":"StepFlow.RightDefinitionView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.RightDefinitionView.html#template_not_found/2","title":"StepFlow.RightDefinitionView.template_not_found/2","type":"function"},{"doc":"","ref":"StepFlow.RightView.html","title":"StepFlow.RightView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.RightView.html#__resource__/0","title":"StepFlow.RightView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.RightView.html#render/2","title":"StepFlow.RightView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.RightView.html#template_not_found/2","title":"StepFlow.RightView.template_not_found/2","type":"function"},{"doc":"The Right context.","ref":"StepFlow.Rights.Right.html","title":"StepFlow.Rights.Right","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"StepFlow.Rights.Right.html#cast/1","title":"StepFlow.Rights.Right.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"StepFlow.Rights.Right.html#dump/1","title":"StepFlow.Rights.Right.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"StepFlow.Rights.Right.html#embed_as/1","title":"StepFlow.Rights.Right.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"StepFlow.Rights.Right.html#equal?/2","title":"StepFlow.Rights.Right.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"StepFlow.Rights.Right.html#load/1","title":"StepFlow.Rights.Right.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"StepFlow.Rights.Right.html#type/0","title":"StepFlow.Rights.Right.type/0","type":"function"},{"doc":"","ref":"StepFlow.Rights.Right.EndpointEnum.html","title":"StepFlow.Rights.Right.EndpointEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"StepFlow.Rights.Right.EndpointEnum.html#cast/1","title":"StepFlow.Rights.Right.EndpointEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"StepFlow.Rights.Right.EndpointEnum.html#dump/1","title":"StepFlow.Rights.Right.EndpointEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"StepFlow.Rights.Right.EndpointEnum.html#embed_as/1","title":"StepFlow.Rights.Right.EndpointEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"StepFlow.Rights.Right.EndpointEnum.html#equal?/2","title":"StepFlow.Rights.Right.EndpointEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"StepFlow.Rights.Right.EndpointEnum.html#load/1","title":"StepFlow.Rights.Right.EndpointEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"StepFlow.Rights.Right.EndpointEnum.html#type/0","title":"StepFlow.Rights.Right.EndpointEnum.type/0","type":"function"},{"doc":"","ref":"StepFlow.Rights.Right.EndpointEnum.html#valid_value?/1","title":"StepFlow.Rights.Right.EndpointEnum.valid_value?/1","type":"function"},{"doc":"","ref":"StepFlow.Rights.Right.EndpointEnum.html#t:t/0","title":"StepFlow.Rights.Right.EndpointEnum.t/0","type":"type"},{"doc":"","ref":"StepFlow.Rights.Right.RightEnum.html","title":"StepFlow.Rights.Right.RightEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"StepFlow.Rights.Right.RightEnum.html#cast/1","title":"StepFlow.Rights.Right.RightEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"StepFlow.Rights.Right.RightEnum.html#dump/1","title":"StepFlow.Rights.Right.RightEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"StepFlow.Rights.Right.RightEnum.html#embed_as/1","title":"StepFlow.Rights.Right.RightEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"StepFlow.Rights.Right.RightEnum.html#equal?/2","title":"StepFlow.Rights.Right.RightEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"StepFlow.Rights.Right.RightEnum.html#load/1","title":"StepFlow.Rights.Right.RightEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"StepFlow.Rights.Right.RightEnum.html#type/0","title":"StepFlow.Rights.Right.RightEnum.type/0","type":"function"},{"doc":"","ref":"StepFlow.Rights.Right.RightEnum.html#valid_value?/1","title":"StepFlow.Rights.Right.RightEnum.valid_value?/1","type":"function"},{"doc":"","ref":"StepFlow.Rights.Right.RightEnum.html#t:t/0","title":"StepFlow.Rights.Right.RightEnum.t/0","type":"type"},{"doc":"","ref":"StepFlow.RoleController.html","title":"StepFlow.RoleController","type":"module"},{"doc":"","ref":"StepFlow.RoleController.html#create/2","title":"StepFlow.RoleController.create/2","type":"function"},{"doc":"","ref":"StepFlow.RoleController.html#delete/2","title":"StepFlow.RoleController.delete/2","type":"function"},{"doc":"","ref":"StepFlow.RoleController.html#index/2","title":"StepFlow.RoleController.index/2","type":"function"},{"doc":"","ref":"StepFlow.RoleController.html#show/2","title":"StepFlow.RoleController.show/2","type":"function"},{"doc":"","ref":"StepFlow.RoleController.html#update/2","title":"StepFlow.RoleController.update/2","type":"function"},{"doc":"","ref":"StepFlow.RoleView.html","title":"StepFlow.RoleView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.RoleView.html#__resource__/0","title":"StepFlow.RoleView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.RoleView.html#render/2","title":"StepFlow.RoleView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.RoleView.html#template_not_found/2","title":"StepFlow.RoleView.template_not_found/2","type":"function"},{"doc":"The Roles context.","ref":"StepFlow.Roles.html","title":"StepFlow.Roles","type":"module"},{"doc":"Returns an %Ecto.Changeset{} for tracking role changes. Examples iex&gt; change_role ( role ) % Ecto.Changeset { source : % Role { } }","ref":"StepFlow.Roles.html#change_role/1","title":"StepFlow.Roles.change_role/1","type":"function"},{"doc":"Creates a role. Examples iex&gt; create_role ( %{ field : value } ) { :ok , % Role { } } iex&gt; create_role ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Roles.html#create_role/1","title":"StepFlow.Roles.create_role/1","type":"function"},{"doc":"Deletes a Role. Examples iex&gt; delete_role ( role ) { :ok , % Role { } } iex&gt; delete_role ( role ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Roles.html#delete_role/1","title":"StepFlow.Roles.delete_role/1","type":"function"},{"doc":"Gets a single role by name Examples iex&gt; get_by! ( toto ) % Role { } iex&gt; get_by! ( tata ) ** (Ecto.NoResultsError)","ref":"StepFlow.Roles.html#get_by!/1","title":"StepFlow.Roles.get_by!/1","type":"function"},{"doc":"Gets a single role by name Examples iex&gt; get_by ( toto ) % Role { } iex&gt; get_by ( tata ) nil","ref":"StepFlow.Roles.html#get_by/1","title":"StepFlow.Roles.get_by/1","type":"function"},{"doc":"Looks for the roles bound to the specified action to execute over the entity type, and returns the related rights.","ref":"StepFlow.Roles.html#get_rights_for_entity_type_and_action/3","title":"StepFlow.Roles.get_rights_for_entity_type_and_action/3","type":"function"},{"doc":"Gets a single role. Raises Ecto.NoResultsError if the Role does not exist. Examples iex&gt; get_role! ( 123 ) % Role { } iex&gt; get_role! ( 456 ) ** (Ecto.NoResultsError)","ref":"StepFlow.Roles.html#get_role!/1","title":"StepFlow.Roles.get_role!/1","type":"function"},{"doc":"Gets a single role. Examples iex&gt; get_role ( 123 ) % Role { } iex&gt; get_role ( 456 ) nil","ref":"StepFlow.Roles.html#get_role/1","title":"StepFlow.Roles.get_role/1","type":"function"},{"doc":"Gets a several roles. Examples iex&gt; get_roles ( [ &quot;toto&quot; , &quot;tata&quot; ] ) [ % Role { } , % Role { } ]","ref":"StepFlow.Roles.html#get_roles/2","title":"StepFlow.Roles.get_roles/2","type":"function"},{"doc":"Returns whether the roles allow to execute the action over the entity.","ref":"StepFlow.Roles.html#has_right?/3","title":"StepFlow.Roles.has_right?/3","type":"function"},{"doc":"Returns the list of roles. Examples iex&gt; list_roles ( ) [ % Role { } , ... ]","ref":"StepFlow.Roles.html#list_roles/1","title":"StepFlow.Roles.list_roles/1","type":"function"},{"doc":"Updates a role. Examples iex&gt; update_role ( role , %{ field : new_value } ) { :ok , % Job { } } iex&gt; update_role ( role , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Roles.html#update_role/2","title":"StepFlow.Roles.update_role/2","type":"function"},{"doc":"","ref":"StepFlow.Router.html","title":"StepFlow.Router","type":"module"},{"doc":"","ref":"StepFlow.Router.html#api/2","title":"StepFlow.Router.api/2","type":"function"},{"doc":"Callback invoked by Plug on every request.","ref":"StepFlow.Router.html#call/2","title":"StepFlow.Router.call/2","type":"function"},{"doc":"Callback required by Plug that initializes the router for serving web requests.","ref":"StepFlow.Router.html#init/1","title":"StepFlow.Router.init/1","type":"function"},{"doc":"","ref":"StepFlow.Router.html#swagger_info/0","title":"StepFlow.Router.swagger_info/0","type":"function"},{"doc":"Module with named helpers generated from StepFlow.Router.","ref":"StepFlow.Router.Helpers.html","title":"StepFlow.Router.Helpers","type":"module"},{"doc":"","ref":"StepFlow.Router.Helpers.html#durations_path/2","title":"StepFlow.Router.Helpers.durations_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#durations_path/3","title":"StepFlow.Router.Helpers.durations_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#durations_url/2","title":"StepFlow.Router.Helpers.durations_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#durations_url/3","title":"StepFlow.Router.Helpers.durations_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#index_path/2","title":"StepFlow.Router.Helpers.index_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#index_path/3","title":"StepFlow.Router.Helpers.index_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#index_path/4","title":"StepFlow.Router.Helpers.index_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#index_url/2","title":"StepFlow.Router.Helpers.index_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#index_url/3","title":"StepFlow.Router.Helpers.index_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#index_url/4","title":"StepFlow.Router.Helpers.index_url/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#job_path/2","title":"StepFlow.Router.Helpers.job_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#job_path/3","title":"StepFlow.Router.Helpers.job_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#job_path/4","title":"StepFlow.Router.Helpers.job_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#job_url/2","title":"StepFlow.Router.Helpers.job_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#job_url/3","title":"StepFlow.Router.Helpers.job_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#job_url/4","title":"StepFlow.Router.Helpers.job_url/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#live_workers_path/2","title":"StepFlow.Router.Helpers.live_workers_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#live_workers_path/3","title":"StepFlow.Router.Helpers.live_workers_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#live_workers_url/2","title":"StepFlow.Router.Helpers.live_workers_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#live_workers_url/3","title":"StepFlow.Router.Helpers.live_workers_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#metric_path/2","title":"StepFlow.Router.Helpers.metric_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#metric_path/3","title":"StepFlow.Router.Helpers.metric_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#metric_url/2","title":"StepFlow.Router.Helpers.metric_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#metric_url/3","title":"StepFlow.Router.Helpers.metric_url/3","type":"function"},{"doc":"Generates the path information including any necessary prefix.","ref":"StepFlow.Router.Helpers.html#path/2","title":"StepFlow.Router.Helpers.path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#right_definition_path/2","title":"StepFlow.Router.Helpers.right_definition_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#right_definition_path/3","title":"StepFlow.Router.Helpers.right_definition_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#right_definition_url/2","title":"StepFlow.Router.Helpers.right_definition_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#right_definition_url/3","title":"StepFlow.Router.Helpers.right_definition_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#role_path/2","title":"StepFlow.Router.Helpers.role_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#role_path/3","title":"StepFlow.Router.Helpers.role_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#role_path/4","title":"StepFlow.Router.Helpers.role_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#role_url/2","title":"StepFlow.Router.Helpers.role_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#role_url/3","title":"StepFlow.Router.Helpers.role_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#role_url/4","title":"StepFlow.Router.Helpers.role_url/4","type":"function"},{"doc":"Generates an integrity hash to a static asset given its file path.","ref":"StepFlow.Router.Helpers.html#static_integrity/2","title":"StepFlow.Router.Helpers.static_integrity/2","type":"function"},{"doc":"Generates path to a static asset given its file path.","ref":"StepFlow.Router.Helpers.html#static_path/2","title":"StepFlow.Router.Helpers.static_path/2","type":"function"},{"doc":"Generates url to a static asset given its file path.","ref":"StepFlow.Router.Helpers.html#static_url/2","title":"StepFlow.Router.Helpers.static_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#statistics_path/2","title":"StepFlow.Router.Helpers.statistics_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#statistics_path/3","title":"StepFlow.Router.Helpers.statistics_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#statistics_url/2","title":"StepFlow.Router.Helpers.statistics_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#statistics_url/3","title":"StepFlow.Router.Helpers.statistics_url/3","type":"function"},{"doc":"Generates the connection/endpoint base URL without any path information.","ref":"StepFlow.Router.Helpers.html#url/1","title":"StepFlow.Router.Helpers.url/1","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#worker_definition_path/2","title":"StepFlow.Router.Helpers.worker_definition_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#worker_definition_path/3","title":"StepFlow.Router.Helpers.worker_definition_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#worker_definition_path/4","title":"StepFlow.Router.Helpers.worker_definition_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#worker_definition_url/2","title":"StepFlow.Router.Helpers.worker_definition_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#worker_definition_url/3","title":"StepFlow.Router.Helpers.worker_definition_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#worker_definition_url/4","title":"StepFlow.Router.Helpers.worker_definition_url/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workers_path/2","title":"StepFlow.Router.Helpers.workers_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workers_path/3","title":"StepFlow.Router.Helpers.workers_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workers_path/4","title":"StepFlow.Router.Helpers.workers_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workers_url/2","title":"StepFlow.Router.Helpers.workers_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workers_url/3","title":"StepFlow.Router.Helpers.workers_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workers_url/4","title":"StepFlow.Router.Helpers.workers_url/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_definition_path/2","title":"StepFlow.Router.Helpers.workflow_definition_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_definition_path/3","title":"StepFlow.Router.Helpers.workflow_definition_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_definition_path/4","title":"StepFlow.Router.Helpers.workflow_definition_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_definition_url/2","title":"StepFlow.Router.Helpers.workflow_definition_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_definition_url/3","title":"StepFlow.Router.Helpers.workflow_definition_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_definition_url/4","title":"StepFlow.Router.Helpers.workflow_definition_url/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_path/2","title":"StepFlow.Router.Helpers.workflow_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_path/3","title":"StepFlow.Router.Helpers.workflow_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_path/4","title":"StepFlow.Router.Helpers.workflow_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_status_path/2","title":"StepFlow.Router.Helpers.workflow_status_path/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_status_path/3","title":"StepFlow.Router.Helpers.workflow_status_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_status_url/2","title":"StepFlow.Router.Helpers.workflow_status_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_status_url/3","title":"StepFlow.Router.Helpers.workflow_status_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_url/2","title":"StepFlow.Router.Helpers.workflow_url/2","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_url/3","title":"StepFlow.Router.Helpers.workflow_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_url/4","title":"StepFlow.Router.Helpers.workflow_url/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_workflow_events_path/3","title":"StepFlow.Router.Helpers.workflow_workflow_events_path/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_workflow_events_path/4","title":"StepFlow.Router.Helpers.workflow_workflow_events_path/4","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_workflow_events_url/3","title":"StepFlow.Router.Helpers.workflow_workflow_events_url/3","type":"function"},{"doc":"","ref":"StepFlow.Router.Helpers.html#workflow_workflow_events_url/4","title":"StepFlow.Router.Helpers.workflow_workflow_events_url/4","type":"function"},{"doc":"Bot connected to Slack if the token is provided. It allow to send notifications to channel.","ref":"StepFlow.SlackBot.html","title":"StepFlow.SlackBot","type":"module"},{"doc":"","ref":"StepFlow.SlackBot.html#child_spec/1","title":"StepFlow.SlackBot.child_spec/1","type":"function"},{"doc":"","ref":"StepFlow.SlackBot.html#handle_close/3","title":"StepFlow.SlackBot.handle_close/3","type":"function"},{"doc":"","ref":"StepFlow.SlackBot.html#handle_connect/2","title":"StepFlow.SlackBot.handle_connect/2","type":"function"},{"doc":"","ref":"StepFlow.SlackBot.html#handle_event/3","title":"StepFlow.SlackBot.handle_event/3","type":"function"},{"doc":"","ref":"StepFlow.SlackBot.html#handle_info/3","title":"StepFlow.SlackBot.handle_info/3","type":"function"},{"doc":"The duration statistics accessor.","ref":"StepFlow.Statistics.Durations.html","title":"StepFlow.Statistics.Durations","type":"module"},{"doc":"","ref":"StepFlow.Statistics.Durations.html#calculate_duration_statistics/1","title":"StepFlow.Statistics.Durations.calculate_duration_statistics/1","type":"function"},{"doc":"","ref":"StepFlow.Statistics.Durations.html#get_jobs_duration_statistics/1","title":"StepFlow.Statistics.Durations.get_jobs_duration_statistics/1","type":"function"},{"doc":"","ref":"StepFlow.Statistics.Durations.html#get_workflows_duration_statistics/1","title":"StepFlow.Statistics.Durations.get_workflows_duration_statistics/1","type":"function"},{"doc":"","ref":"StepFlow.Statistics.Durations.html#list_durations_for_jobs/1","title":"StepFlow.Statistics.Durations.list_durations_for_jobs/1","type":"function"},{"doc":"","ref":"StepFlow.Statistics.Durations.html#list_durations_for_workflows/1","title":"StepFlow.Statistics.Durations.list_durations_for_workflows/1","type":"function"},{"doc":"","ref":"StepFlow.StatusView.html","title":"StepFlow.StatusView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.StatusView.html#__resource__/0","title":"StepFlow.StatusView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.StatusView.html#render/2","title":"StepFlow.StatusView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.StatusView.html#template_not_found/2","title":"StepFlow.StatusView.template_not_found/2","type":"function"},{"doc":"The Step context.","ref":"StepFlow.Step.html","title":"StepFlow.Step","type":"module"},{"doc":"","ref":"StepFlow.Step.html#abort_step_jobs/2","title":"StepFlow.Step.abort_step_jobs/2","type":"function"},{"doc":"","ref":"StepFlow.Step.html#pause_step/3","title":"StepFlow.Step.pause_step/3","type":"function"},{"doc":"","ref":"StepFlow.Step.html#resume_step/2","title":"StepFlow.Step.resume_step/2","type":"function"},{"doc":"","ref":"StepFlow.Step.html#skip_step/2","title":"StepFlow.Step.skip_step/2","type":"function"},{"doc":"","ref":"StepFlow.Step.html#skip_step_jobs/2","title":"StepFlow.Step.skip_step_jobs/2","type":"function"},{"doc":"","ref":"StepFlow.Step.html#start_next/1","title":"StepFlow.Step.start_next/1","type":"function"},{"doc":"The Helper Step context.","ref":"StepFlow.Step.Helpers.html","title":"StepFlow.Step.Helpers","type":"module"},{"doc":"","ref":"StepFlow.Step.Helpers.html#add_required_paths/2","title":"StepFlow.Step.Helpers.add_required_paths/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#filter_empty/1","title":"StepFlow.Step.Helpers.filter_empty/1","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#filter_empty_templated/1","title":"StepFlow.Step.Helpers.filter_empty_templated/1","type":"function"},{"doc":"Filter a list of paths. Examples iex&gt; StepFlow.Step.Helpers . filter_path_list ( [ &quot;path_1.ext1&quot; , &quot;path2.ext2&quot; ] , [ %{ &quot;ends_with&quot; =&gt; &quot;.ext2&quot; } ] ) [ &quot;path2.ext2&quot; ] iex&gt; StepFlow.Step.Helpers . filter_path_list ( [ &quot;path_1.ext1&quot; , &quot;path2.ext2&quot; ] , [ %{ ends_with : &quot;.ext2&quot; } ] ) [ &quot;path2.ext2&quot; ]","ref":"StepFlow.Step.Helpers.html#filter_path_list/2","title":"StepFlow.Step.Helpers.filter_path_list/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#filter_untemplated/1","title":"StepFlow.Step.Helpers.filter_untemplated/1","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_base_directory/2","title":"StepFlow.Step.Helpers.get_base_directory/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_dates/0","title":"StepFlow.Step.Helpers.get_dates/0","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_job_destination_paths/1","title":"StepFlow.Step.Helpers.get_job_destination_paths/1","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_jobs_destination_paths/1","title":"StepFlow.Step.Helpers.get_jobs_destination_paths/1","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_required_paths/2","title":"StepFlow.Step.Helpers.get_required_paths/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_step_requirements/2","title":"StepFlow.Step.Helpers.get_step_requirements/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_string_or_processed_template_value/6","title":"StepFlow.Step.Helpers.get_string_or_processed_template_value/6","type":"function"},{"doc":"Retrieves a value on an Objecta and filtered by the key.","ref":"StepFlow.Step.Helpers.html#get_value_in_parameters/2","title":"StepFlow.Step.Helpers.get_value_in_parameters/2","type":"function"},{"doc":"Retrieves a value on an Object and filtered by the key and type.","ref":"StepFlow.Step.Helpers.html#get_value_in_parameters_with_type/3","title":"StepFlow.Step.Helpers.get_value_in_parameters_with_type/3","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#get_work_directory/1","title":"StepFlow.Step.Helpers.get_work_directory/1","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#template_process/5","title":"StepFlow.Step.Helpers.template_process/5","type":"function"},{"doc":"","ref":"StepFlow.Step.Helpers.html#templates_process/5","title":"StepFlow.Step.Helpers.templates_process/5","type":"function"},{"doc":"The Step launcher context.","ref":"StepFlow.Step.Launch.html","title":"StepFlow.Step.Launch","type":"module"},{"doc":"","ref":"StepFlow.Step.Launch.html#build_requirements_and_destination_path/7","title":"StepFlow.Step.Launch.build_requirements_and_destination_path/7","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#build_requirements_and_destination_path/8","title":"StepFlow.Step.Launch.build_requirements_and_destination_path/8","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#generate_job_one_for_many/2","title":"StepFlow.Step.Launch.generate_job_one_for_many/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#generate_job_one_for_one/2","title":"StepFlow.Step.Launch.generate_job_one_for_one/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#generate_job_parameters_one_for_one/2","title":"StepFlow.Step.Launch.generate_job_parameters_one_for_one/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#generate_message_one_for_many/2","title":"StepFlow.Step.Launch.generate_message_one_for_many/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#generate_message_one_for_one/2","title":"StepFlow.Step.Launch.generate_message_one_for_one/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#get_source_paths/3","title":"StepFlow.Step.Launch.get_source_paths/3","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#launch_step/2","title":"StepFlow.Step.Launch.launch_step/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Launch.html#start_job_one_for_many/2","title":"StepFlow.Step.Launch.start_job_one_for_many/2","type":"function"},{"doc":"The Step launching parameters.","ref":"StepFlow.Step.LaunchParams.html","title":"StepFlow.Step.LaunchParams","type":"module"},{"doc":"","ref":"StepFlow.Step.LaunchParams.html#get_step_allow_failure/1","title":"StepFlow.Step.LaunchParams.get_step_allow_failure/1","type":"function"},{"doc":"","ref":"StepFlow.Step.LaunchParams.html#get_step_id/1","title":"StepFlow.Step.LaunchParams.get_step_id/1","type":"function"},{"doc":"","ref":"StepFlow.Step.LaunchParams.html#get_step_name/1","title":"StepFlow.Step.LaunchParams.get_step_name/1","type":"function"},{"doc":"","ref":"StepFlow.Step.LaunchParams.html#get_step_parameter/2","title":"StepFlow.Step.LaunchParams.get_step_parameter/2","type":"function"},{"doc":"","ref":"StepFlow.Step.LaunchParams.html#new/3","title":"StepFlow.Step.LaunchParams.new/3","type":"function"},{"doc":"","ref":"StepFlow.Step.LaunchParams.html#new/4","title":"StepFlow.Step.LaunchParams.new/4","type":"function"},{"doc":"The Live step context.","ref":"StepFlow.Step.Live.html","title":"StepFlow.Step.Live","type":"module"},{"doc":"","ref":"StepFlow.Step.Live.html#create_job_live/2","title":"StepFlow.Step.Live.create_job_live/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Live.html#generate_message/2","title":"StepFlow.Step.Live.generate_message/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Live.html#generate_message_live/2","title":"StepFlow.Step.Live.generate_message_live/2","type":"function"},{"doc":"","ref":"StepFlow.Step.Live.html#stop_job/1","title":"StepFlow.Step.Live.stop_job/1","type":"function"},{"doc":"","ref":"StepFlow.Step.Live.html#stop_jobs/1","title":"StepFlow.Step.Live.stop_jobs/1","type":"function"},{"doc":"","ref":"StepFlow.Step.Live.html#update_job_live/1","title":"StepFlow.Step.Live.update_job_live/1","type":"function"},{"doc":"The Updates context.","ref":"StepFlow.Updates.html","title":"StepFlow.Updates","type":"module"},{"doc":"Creates an update. Examples iex&gt; create_update ( %{ field : value } ) { :ok , % Update { } } iex&gt; create_update ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Updates.html#create_update/1","title":"StepFlow.Updates.create_update/1","type":"function"},{"doc":"","ref":"StepFlow.Updates.html#update_parameter/2","title":"StepFlow.Updates.update_parameter/2","type":"function"},{"doc":"","ref":"StepFlow.Updates.html#update_parameters/2","title":"StepFlow.Updates.update_parameters/2","type":"function"},{"doc":"","ref":"StepFlow.UpdatesView.html","title":"StepFlow.UpdatesView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.UpdatesView.html#__resource__/0","title":"StepFlow.UpdatesView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.UpdatesView.html#render/2","title":"StepFlow.UpdatesView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.UpdatesView.html#template_not_found/2","title":"StepFlow.UpdatesView.template_not_found/2","type":"function"},{"doc":"","ref":"StepFlow.WorkerDefinitionController.html","title":"StepFlow.WorkerDefinitionController","type":"module"},{"doc":"","ref":"StepFlow.WorkerDefinitionController.html#create/2","title":"StepFlow.WorkerDefinitionController.create/2","type":"function"},{"doc":"","ref":"StepFlow.WorkerDefinitionController.html#index/2","title":"StepFlow.WorkerDefinitionController.index/2","type":"function"},{"doc":"","ref":"StepFlow.WorkerDefinitionController.html#show/2","title":"StepFlow.WorkerDefinitionController.show/2","type":"function"},{"doc":"","ref":"StepFlow.WorkerDefinitionView.html","title":"StepFlow.WorkerDefinitionView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.WorkerDefinitionView.html#__resource__/0","title":"StepFlow.WorkerDefinitionView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.WorkerDefinitionView.html#render/2","title":"StepFlow.WorkerDefinitionView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.WorkerDefinitionView.html#template_not_found/2","title":"StepFlow.WorkerDefinitionView.template_not_found/2","type":"function"},{"doc":"The WorkerDefinitions context.","ref":"StepFlow.WorkerDefinitions.html","title":"StepFlow.WorkerDefinitions","type":"module"},{"doc":"Creates a WorkerDefinition. Examples iex&gt; result = StepFlow.WorkerDefinitions . create_worker_definition ( %{ ...&gt; queue_name : &quot;my_queue&quot; , ...&gt; label : &quot;My Queue&quot; , ...&gt; version : &quot;1.2.3&quot; , ...&gt; short_description : &quot;short description&quot; , ...&gt; description : &quot;long description&quot; , ...&gt; parameters : %{ } ...&gt; } ) ...&gt; match? ( { :ok , % StepFlow.WorkerDefinitions.WorkerDefinition { } } , result ) true iex&gt; result = StepFlow.WorkerDefinitions . create_worker_definition ( %{ field : :bad_value } ) ...&gt; match? ( { :error , % Ecto.Changeset { } } , result ) true","ref":"StepFlow.WorkerDefinitions.html#create_worker_definition/1","title":"StepFlow.WorkerDefinitions.create_worker_definition/1","type":"function"},{"doc":"","ref":"StepFlow.WorkerDefinitions.html#exists/1","title":"StepFlow.WorkerDefinitions.exists/1","type":"function"},{"doc":"Gets a single WorkerDefinition. Raises Ecto.NoResultsError if the WorkerDefinition does not exist.","ref":"StepFlow.WorkerDefinitions.html#get_worker_definition!/1","title":"StepFlow.WorkerDefinitions.get_worker_definition!/1","type":"function"},{"doc":"Returns the list of WorkerDefinitions. Examples iex&gt; StepFlow.WorkerDefinitions . list_worker_definitions ( ) %{ data : [ ] , page : 0 , size : 10 , total : 0 }","ref":"StepFlow.WorkerDefinitions.html#list_worker_definitions/1","title":"StepFlow.WorkerDefinitions.list_worker_definitions/1","type":"function"},{"doc":"","ref":"StepFlow.WorkerStatusView.html","title":"StepFlow.WorkerStatusView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.WorkerStatusView.html#__resource__/0","title":"StepFlow.WorkerStatusView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.WorkerStatusView.html#render/2","title":"StepFlow.WorkerStatusView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.WorkerStatusView.html#template_not_found/2","title":"StepFlow.WorkerStatusView.template_not_found/2","type":"function"},{"doc":"","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html","title":"StepFlow.Workers.WorkerStatus.ActivityEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#cast/1","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#dump/1","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#embed_as/1","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#equal?/2","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#load/1","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#type/0","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.type/0","type":"function"},{"doc":"","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#valid_value?/1","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.valid_value?/1","type":"function"},{"doc":"","ref":"StepFlow.Workers.WorkerStatus.ActivityEnum.html#t:t/0","title":"StepFlow.Workers.WorkerStatus.ActivityEnum.t/0","type":"type"},{"doc":"","ref":"StepFlow.Workers.WorkerStatus.JobStatus.html","title":"StepFlow.Workers.WorkerStatus.JobStatus","type":"module"},{"doc":"The WorkerStatuses context.","ref":"StepFlow.Workers.WorkerStatuses.html","title":"StepFlow.Workers.WorkerStatuses","type":"module"},{"doc":"Creates a WorkerStatus. Examples iex&gt; result = StepFlow.Workers.WorkerStatuses . create_worker_status! ( %{ ...&gt; job : nil , ...&gt; worker : %{ ...&gt; activity : &quot;Idle&quot; , ...&gt; description : &quot;This worker is just an example.&quot; , ...&gt; direct_messaging_queue_name : &quot;direct_messaging_e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; instance_id : &quot;e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; label : &quot;UnitTestWorker&quot; , ...&gt; queue_name : &quot;job_test_worker&quot; , ...&gt; sdk_version : &quot;2.3.4&quot; , ...&gt; short_description : &quot;A test worker&quot; , ...&gt; system_info : %{ ...&gt; docker_container_id : &quot;e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; number_of_processors : 12 , ...&gt; total_memory : 16_574_754 , ...&gt; total_swap : 2_046_816 , ...&gt; used_memory : 8_865_633 , ...&gt; used_swap : 0 ...&gt; } , ...&gt; version : &quot;1.2.3&quot; ...&gt; } ...&gt; } ) ...&gt; match? ( % StepFlow.Workers.WorkerStatus { } , result ) true Raises error if something went wrong during creation.","ref":"StepFlow.Workers.WorkerStatuses.html#create_worker_status!/1","title":"StepFlow.Workers.WorkerStatuses.create_worker_status!/1","type":"function"},{"doc":"Creates a WorkerStatus. Examples iex&gt; result = StepFlow.Workers.WorkerStatuses . create_worker_status! ( %{ ...&gt; job : nil , ...&gt; worker : %{ ...&gt; activity : &quot;Idle&quot; , ...&gt; description : &quot;This worker is just an example.&quot; , ...&gt; direct_messaging_queue_name : &quot;direct_messaging_e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; instance_id : &quot;e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; label : &quot;UnitTestWorker&quot; , ...&gt; queue_name : &quot;job_test_worker&quot; , ...&gt; sdk_version : &quot;2.3.4&quot; , ...&gt; short_description : &quot;A test worker&quot; , ...&gt; system_info : %{ ...&gt; docker_container_id : &quot;e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; number_of_processors : 12 , ...&gt; total_memory : 16_574_754 , ...&gt; total_swap : 2_046_816 , ...&gt; used_memory : 8_865_633 , ...&gt; used_swap : 0 ...&gt; } , ...&gt; version : &quot;1.2.3&quot; ...&gt; } ...&gt; } ) ...&gt; match? ( % StepFlow.Workers.WorkerStatus { } , result ) true Returns {:ok, WorkerStatus} on success, {:error, changeset} otherwise.","ref":"StepFlow.Workers.WorkerStatuses.html#create_worker_status/1","title":"StepFlow.Workers.WorkerStatuses.create_worker_status/1","type":"function"},{"doc":"Gets the last inserted WorkerStatus. Raises Ecto.NoResultsError if the WorkerStatus does not exist.","ref":"StepFlow.Workers.WorkerStatuses.html#get_worker_status!/1","title":"StepFlow.Workers.WorkerStatuses.get_worker_status!/1","type":"function"},{"doc":"Gets the last inserted WorkerStatus. Returns nil if the Worker does not exist.","ref":"StepFlow.Workers.WorkerStatuses.html#get_worker_status/1","title":"StepFlow.Workers.WorkerStatuses.get_worker_status/1","type":"function"},{"doc":"Gets the first WorkerStatus which is running a job which ID is job_id . Returns nil if that WorkerStatus does not exist.","ref":"StepFlow.Workers.WorkerStatuses.html#get_worker_status_for_job/1","title":"StepFlow.Workers.WorkerStatuses.get_worker_status_for_job/1","type":"function"},{"doc":"Returns the list of WorkerStatuses. Examples iex&gt; StepFlow.WorkerStatuses . list_worker_statuses ( ) %{ data : [ ] , page : 0 , size : 10 , total : 0 }","ref":"StepFlow.Workers.WorkerStatuses.html#list_worker_statuses/1","title":"StepFlow.Workers.WorkerStatuses.list_worker_statuses/1","type":"function"},{"doc":"Updates a WorkerStatus. Examples iex&gt; result = StepFlow.Workers.WorkerStatuses . update_worker_status! ( %{ ...&gt; job : %{ ...&gt; destination_paths : [ ] , ...&gt; execution_duration : 0.0 , ...&gt; job_id : 1234 , ...&gt; parameters : [ ] , ...&gt; status : &quot;processing&quot; ...&gt; } , ...&gt; worker : %{ ...&gt; activity : &quot;Idle&quot; , ...&gt; description : &quot;This worker is just an example.&quot; , ...&gt; direct_messaging_queue_name : &quot;direct_messaging_e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; instance_id : &quot;e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; label : &quot;UnitTestWorker&quot; , ...&gt; queue_name : &quot;job_test_worker&quot; , ...&gt; sdk_version : &quot;2.3.4&quot; , ...&gt; short_description : &quot;A test worker&quot; , ...&gt; system_info : %{ ...&gt; docker_container_id : &quot;e1297fe6-fe94-49cf-9ef8-1a751cba28f2&quot; , ...&gt; number_of_processors : 12 , ...&gt; total_memory : 16_574_754 , ...&gt; total_swap : 2_046_816 , ...&gt; used_memory : 8_865_633 , ...&gt; used_swap : 0 ...&gt; } , ...&gt; version : &quot;1.2.3&quot; ...&gt; } ...&gt; } ) ...&gt; match? ( % StepFlow.Workers.WorkerStatus { } , result ) true Raises error if something went wrong during update.","ref":"StepFlow.Workers.WorkerStatuses.html#update_worker_status!/2","title":"StepFlow.Workers.WorkerStatuses.update_worker_status!/2","type":"function"},{"doc":"","ref":"StepFlow.WorkersController.html","title":"StepFlow.WorkersController","type":"module"},{"doc":"","ref":"StepFlow.WorkersController.html#index/2","title":"StepFlow.WorkersController.index/2","type":"function"},{"doc":"","ref":"StepFlow.WorkersController.html#show/2","title":"StepFlow.WorkersController.show/2","type":"function"},{"doc":"","ref":"StepFlow.WorkersController.html#update/2","title":"StepFlow.WorkersController.update/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html","title":"StepFlow.WorkflowController","type":"module"},{"doc":"","ref":"StepFlow.WorkflowController.html#create/2","title":"StepFlow.WorkflowController.create/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#create_workflow/2","title":"StepFlow.WorkflowController.create_workflow/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#delete/2","title":"StepFlow.WorkflowController.delete/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#get/2","title":"StepFlow.WorkflowController.get/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#index/2","title":"StepFlow.WorkflowController.index/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#locate_and_create_workflow/4","title":"StepFlow.WorkflowController.locate_and_create_workflow/4","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#show/2","title":"StepFlow.WorkflowController.show/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#statistics/2","title":"StepFlow.WorkflowController.statistics/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowController.html#update/2","title":"StepFlow.WorkflowController.update/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowDefinitionController.html","title":"StepFlow.WorkflowDefinitionController","type":"module"},{"doc":"","ref":"StepFlow.WorkflowDefinitionController.html#create/2","title":"StepFlow.WorkflowDefinitionController.create/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowDefinitionController.html#index/2","title":"StepFlow.WorkflowDefinitionController.index/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowDefinitionController.html#show/2","title":"StepFlow.WorkflowDefinitionController.show/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowDefinitionController.html#swagger_path_index/1","title":"StepFlow.WorkflowDefinitionController.swagger_path_index/1","type":"function"},{"doc":"","ref":"StepFlow.WorkflowDefinitionView.html","title":"StepFlow.WorkflowDefinitionView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.WorkflowDefinitionView.html#__resource__/0","title":"StepFlow.WorkflowDefinitionView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.WorkflowDefinitionView.html#render/2","title":"StepFlow.WorkflowDefinitionView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.WorkflowDefinitionView.html#template_not_found/2","title":"StepFlow.WorkflowDefinitionView.template_not_found/2","type":"function"},{"doc":"The WorkflowDefinitions context.","ref":"StepFlow.WorkflowDefinitions.html","title":"StepFlow.WorkflowDefinitions","type":"module"},{"doc":"","ref":"StepFlow.WorkflowDefinitions.html#filter_by_versions/2","title":"StepFlow.WorkflowDefinitions.filter_by_versions/2","type":"function"},{"doc":"Gets a single WorkflowDefinition (latest version). Returns nil if the WorkflowDefinition does not exist.","ref":"StepFlow.WorkflowDefinitions.html#get_workflow_definition/1","title":"StepFlow.WorkflowDefinitions.get_workflow_definition/1","type":"function"},{"doc":"Gets a single WorkflowDefinition by specifying the version. Returns nil if the WorkflowDefinition does not exist.","ref":"StepFlow.WorkflowDefinitions.html#get_workflow_definition/4","title":"StepFlow.WorkflowDefinitions.get_workflow_definition/4","type":"function"},{"doc":"Get workflow definitions from directories","ref":"StepFlow.WorkflowDefinitions.html#get_workflow_definition_directories/0","title":"StepFlow.WorkflowDefinitions.get_workflow_definition_directories/0","type":"function"},{"doc":"Returns the list of Workflow Definitions.","ref":"StepFlow.WorkflowDefinitions.html#list_workflow_definitions/1","title":"StepFlow.WorkflowDefinitions.list_workflow_definitions/1","type":"function"},{"doc":"Loads workflows","ref":"StepFlow.WorkflowDefinitions.html#load_workflows/0","title":"StepFlow.WorkflowDefinitions.load_workflows/0","type":"function"},{"doc":"Loads workflows in database","ref":"StepFlow.WorkflowDefinitions.html#load_workflows_in_database/0","title":"StepFlow.WorkflowDefinitions.load_workflows_in_database/0","type":"function"},{"doc":"","ref":"StepFlow.WorkflowDefinitions.html#valid?/1","title":"StepFlow.WorkflowDefinitions.valid?/1","type":"function"},{"doc":"","ref":"StepFlow.WorkflowDefinitions.html#validate/1","title":"StepFlow.WorkflowDefinitions.validate/1","type":"function"},{"doc":"Loader for referenced JSON schema implemented through Xema loader.","ref":"StepFlow.WorkflowDefinitions.ExternalLoader.html","title":"StepFlow.WorkflowDefinitions.ExternalLoader","type":"module"},{"doc":"Callback implementation for Xema.Loader.fetch/1 .","ref":"StepFlow.WorkflowDefinitions.ExternalLoader.html#fetch/1","title":"StepFlow.WorkflowDefinitions.ExternalLoader.fetch/1","type":"function"},{"doc":"The WorkflowDefinition context.","ref":"StepFlow.WorkflowDefinitions.WorkflowDefinition.html","title":"StepFlow.WorkflowDefinitions.WorkflowDefinition","type":"module"},{"doc":"","ref":"StepFlow.WorkflowEventsController.html","title":"StepFlow.WorkflowEventsController","type":"module"},{"doc":"","ref":"StepFlow.WorkflowEventsController.html#handle/2","title":"StepFlow.WorkflowEventsController.handle/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowStatusController.html","title":"StepFlow.WorkflowStatusController","type":"module"},{"doc":"","ref":"StepFlow.WorkflowStatusController.html#list/2","title":"StepFlow.WorkflowStatusController.list/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowStatusView.html","title":"StepFlow.WorkflowStatusView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.WorkflowStatusView.html#__resource__/0","title":"StepFlow.WorkflowStatusView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.WorkflowStatusView.html#render/2","title":"StepFlow.WorkflowStatusView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.WorkflowStatusView.html#template_not_found/2","title":"StepFlow.WorkflowStatusView.template_not_found/2","type":"function"},{"doc":"","ref":"StepFlow.WorkflowView.html","title":"StepFlow.WorkflowView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"StepFlow.WorkflowView.html#__resource__/0","title":"StepFlow.WorkflowView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"StepFlow.WorkflowView.html#render/2","title":"StepFlow.WorkflowView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"StepFlow.WorkflowView.html#template_not_found/2","title":"StepFlow.WorkflowView.template_not_found/2","type":"function"},{"doc":"The Workflows context.","ref":"StepFlow.Workflows.html","title":"StepFlow.Workflows","type":"module"},{"doc":"","ref":"StepFlow.Workflows.html#abort/1","title":"StepFlow.Workflows.abort/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#apply_default_query_filters/2","title":"StepFlow.Workflows.apply_default_query_filters/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking workflow changes. Examples iex&gt; change_workflow ( workflow ) % Ecto.Changeset { source : % Workflow { } }","ref":"StepFlow.Workflows.html#change_workflow/1","title":"StepFlow.Workflows.change_workflow/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#check_rights/1","title":"StepFlow.Workflows.check_rights/1","type":"function"},{"doc":"Creates a workflow. Examples iex&gt; create_workflow ( %{ field : value } ) { :ok , % Workflow { } } iex&gt; create_workflow ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Workflows.html#create_workflow/1","title":"StepFlow.Workflows.create_workflow/1","type":"function"},{"doc":"Deletes a Workflow. Examples iex&gt; delete_workflow ( workflow ) { :ok , % Workflow { } } iex&gt; delete_workflow ( workflow ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Workflows.html#delete_workflow/1","title":"StepFlow.Workflows.delete_workflow/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#filter_status/3","title":"StepFlow.Workflows.filter_status/3","type":"function"},{"doc":"Returns an attribute map to have a workflow configuration.","ref":"StepFlow.Workflows.html#get_attr/1","title":"StepFlow.Workflows.get_attr/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#get_completed_statistics/2","title":"StepFlow.Workflows.get_completed_statistics/2","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#get_step_definition/1","title":"StepFlow.Workflows.get_step_definition/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#get_steps_with_status/3","title":"StepFlow.Workflows.get_steps_with_status/3","type":"function"},{"doc":"Gets a single workflows. Raises Ecto.NoResultsError if the Workflow does not exist. Examples iex&gt; get_workflows! ( 123 ) % Workflow { } iex&gt; get_workflows! ( 456 ) ** (Ecto.NoResultsError)","ref":"StepFlow.Workflows.html#get_workflow!/1","title":"StepFlow.Workflows.get_workflow!/1","type":"function"},{"doc":"Gets a single workflows containing the specified job ID. Raises Ecto.NoResultsError if the Workflow does not exist. Examples iex&gt; get_workflow_for_job! ( 19 ) % Workflow { } iex&gt; get_workflows! ( 456 ) ** (Ecto.NoResultsError)","ref":"StepFlow.Workflows.html#get_workflow_for_job!/1","title":"StepFlow.Workflows.get_workflow_for_job!/1","type":"function"},{"doc":"Convert workflow version fields to a version string","ref":"StepFlow.Workflows.html#get_workflow_version_as_string/1","title":"StepFlow.Workflows.get_workflow_version_as_string/1","type":"function"},{"doc":"Returns the list of workflows. Examples iex&gt; list_workflows ( ) [ % Workflow { } , ... ]","ref":"StepFlow.Workflows.html#list_workflows/1","title":"StepFlow.Workflows.list_workflows/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#notification_from_job/2","title":"StepFlow.Workflows.notification_from_job/2","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#notification_hook_from_workflow/5","title":"StepFlow.Workflows.notification_hook_from_workflow/5","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#notification_slack_from_job/4","title":"StepFlow.Workflows.notification_slack_from_job/4","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#notification_teams_from_job/5","title":"StepFlow.Workflows.notification_teams_from_job/5","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#notification_workflow_status/2","title":"StepFlow.Workflows.notification_workflow_status/2","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#pause/3","title":"StepFlow.Workflows.pause/3","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#preload_workflows/2","title":"StepFlow.Workflows.preload_workflows/2","type":"function"},{"doc":"","ref":"StepFlow.Workflows.html#resume/1","title":"StepFlow.Workflows.resume/1","type":"function"},{"doc":"Updates a workflow. Examples iex&gt; update_workflow ( workflow , %{ field : new_value } ) { :ok , % Workflow { } } iex&gt; update_workflow ( workflow , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"StepFlow.Workflows.html#update_workflow/2","title":"StepFlow.Workflows.update_workflow/2","type":"function"},{"doc":"","ref":"StepFlow.Workflows.Status.StateEnum.html","title":"StepFlow.Workflows.Status.StateEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"StepFlow.Workflows.Status.StateEnum.html#cast/1","title":"StepFlow.Workflows.Status.StateEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"StepFlow.Workflows.Status.StateEnum.html#dump/1","title":"StepFlow.Workflows.Status.StateEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"StepFlow.Workflows.Status.StateEnum.html#embed_as/1","title":"StepFlow.Workflows.Status.StateEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"StepFlow.Workflows.Status.StateEnum.html#equal?/2","title":"StepFlow.Workflows.Status.StateEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"StepFlow.Workflows.Status.StateEnum.html#load/1","title":"StepFlow.Workflows.Status.StateEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"StepFlow.Workflows.Status.StateEnum.html#type/0","title":"StepFlow.Workflows.Status.StateEnum.type/0","type":"function"},{"doc":"","ref":"StepFlow.Workflows.Status.StateEnum.html#valid_value?/1","title":"StepFlow.Workflows.Status.StateEnum.valid_value?/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.Status.StateEnum.html#t:t/0","title":"StepFlow.Workflows.Status.StateEnum.t/0","type":"type"},{"doc":"The Step Manager context.","ref":"StepFlow.Workflows.StepManager.html","title":"StepFlow.Workflows.StepManager","type":"module"},{"doc":"","ref":"StepFlow.Workflows.StepManager.html#check_step_progression/1","title":"StepFlow.Workflows.StepManager.check_step_progression/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.StepManager.html#check_step_status/1","title":"StepFlow.Workflows.StepManager.check_step_status/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"StepFlow.Workflows.StepManager.html#child_spec/1","title":"StepFlow.Workflows.StepManager.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"StepFlow.Workflows.StepManager.html#init/1","title":"StepFlow.Workflows.StepManager.init/1","type":"function"},{"doc":"","ref":"StepFlow.Workflows.StepManager.html#start_link/0","title":"StepFlow.Workflows.StepManager.start_link/0","type":"function"},{"doc":"Step flow manager for Elixir applications.","ref":"readme.html","title":"Step Flow","type":"extras"},{"doc":"Add AMQP as a dependency in your mix.exs file. def deps do [ { :step_flow , &quot;~&gt; 0.1.0&quot; } ] end And add into extra applications: def application do [ mod : { MyApplication.Application , [ ] } , extra_applications : [ :step_flow ] ] end","ref":"readme.html#usage","title":"Step Flow - Usage","type":"extras"},{"doc":"The state machines are described in dedicated pages, for workflows and for jobs respectively.","ref":"readme.html#workflows-and-jobs-state-machines","title":"Step Flow - Workflows and Jobs State Machines","type":"extras"},{"doc":"PostgreSQL configuration Add into configuration files: config :step_flow , Ecto.Repo , hostname : &quot;localhost&quot; , username : &quot;postgres&quot; , password : &quot;postgres&quot; , database : &quot;step_flow_dev&quot; , runtime_pool_size : 10 It can also be used with environment variables: config :step_flow , Ecto.Repo , hostname : { :system , &quot;DATABASE_HOSTNAME&quot; } , username : { :system , &quot;DATABASE_USERNAME&quot; } , password : { :system , &quot;DATABASE_PASSWORD&quot; } , database : { :system , &quot;DATABASE_NAME&quot; } , runtime_pool_size : { :system , &quot;DATABASE_POOL_SIZE&quot; } RabbitMQ configuration Add into configuration files: config :step_flow , StepFlow.Amqp , hostname : &quot;localhost&quot; , port : 5672 , username : &quot;guest&quot; , password : &quot;guest&quot; , virtual_host : &quot;&quot; To set TLS over AMQP, specific configuration fields can be added: config :step_flow , StepFlow.Amqp , hostname : &quot;localhost&quot; , port : 5672 , username : &quot;guest&quot; , password : &quot;guest&quot; , virtual_host : &quot;&quot; , scheme : &quot;amqp&quot; , ssl_cacertfile : &#39;/path/to/ca/cacert.pem&#39; , ssl_certfile : &#39;/path/to/client/cert.pem&#39; , ssl_keyfile : &#39;/path/to/client/key.pem&#39; , # only necessary with intermediate CAs ssl_depth : 2 , ssl_verify : :verify_peer , ssl_fail_if_no_peer_cert : true It can also be used with environment variables: config :step_flow , StepFlow.Amqp , hostname : { :system , &quot;RABBITMQ_HOSTNAME&quot; } , port : { :system , &quot;RABBITMQ_PORT&quot; } , username : { :system , &quot;RABBITMQ_USERNAME&quot; } , password : { :system , &quot;RABBITMQ_PASSWORD&quot; } , virtual_host : { :system , &quot;RABBITMQ_VIRTUAL_HOST&quot; } , scheme : { :system , &quot;RABBITMQ_SCHEME&quot; } , ssl_cacertfile : { :system , &quot;RABBITMQ_SSL_CACERT_FILE&quot; } , ssl_certfile : { :system , &quot;RABBITMQ_SSL_CERT_FILE&quot; } , ssl_keyfile : { :system , &quot;RABBITMQ_SSL_KEY_FILE&quot; } , ssl_depth : { :system , &quot;RABBITMQ_SSL_DEPTH&quot; } , ssl_verify : { :system , &quot;RABBITMQ_SSL_VERIFY&quot; } , ssl_fail_if_no_peer_cert : { :system , &quot;RABBITMQ_SSL_FAIL_IF_NO_PEER_CERT&quot; } Slack integration (optional) Configuring the Slack integration enable notification to Slack channel. It's used to: send notification when job is in error send a notification via a Step To enable integration, update configuration files: config :step_flow , StepFlow , exposed_domain_name : { :system , &quot;EXPOSED_DOMAIN_NAME&quot; } , slack_api_token : { :system , &quot;SLACK_API_TOKEN&quot; } , slack_api_channel : { :system , &quot;SLACK_API_CHANNEL&quot; } Remarks: the slack_api_channel configure the channel for error jobs notification. The message contains also a link to the workflow, so exposed_domain_name configure the hostname of the hosted application. Expose StepFlow REST API Step Flow provides the REST API to manage Workflows and Jobs. Create a module with: defmodule MyApplicationWeb.StepFlow.Plug do @moduledoc false use StepFlow.Plug end Then in Phoenix router redirect the API part to the module: defmodule MyApplicationWeb.Router do use MyApplicationWeb , :router pipeline :api do plug ( :accepts , [ &quot;json&quot; ] ) end scope &quot;/api&quot; , MyApplicationWeb do pipe_through ( :api ) scope &quot;/step_flow&quot; , StepFlow do forward ( &quot;/&quot; , Plug ) end # add other routes here end end To enable authentication checks over Step Flow API configure callbacks in configuration: config :step_flow , StepFlow , authorize : [ module : MyApplicationWeb.Authorize , get_jobs : [ :user_check , :right_technician_check ] , get_workflows : [ :user_check , :right_technician_check ] , post_workflows : [ :user_check , :right_technician_check ] , put_workflows : [ :user_check , :right_technician_check ] , delete_workflows : [ :user_check , :right_technician_check ] , post_workflows_events : [ :user_check , :right_technician_check ] , get_definitions : [ :user_check , :right_technician_check ] , post_worker_definitions : [ :user_check , :right_technician_check ] , get_worker_definitions : [ :user_check , :right_technician_check ] , get_workflows_statistics : [ :user_check ] ] Enable StepFlow live notification to WebSocket StepFlow can be configured to send messages on job updates (to enable refresh of UI via WebSocket for example). To broadcast messages, the application endpoint needs to be configured. config :step_flow , StepFlow , endpoint : MyApplicationWeb.Endpoint Configuration of the default working directory for workers Each workers works with big data files, mostly on shared storage. The default access point need to be configured using: config :step_flow , StepFlow , workers_work_directory : &quot;/data/mount/point&quot; Configuration of the default stepflow schema A workflow follows a schema definition, this definition can be overloaded with: config :step_flow , StepFlow.WorkflowDefinitions.ExternalLoader , specification_folder : &quot;./mediacloudai/&quot; config :step_flow , StepFlow.WorkflowDefinitions.WorkflowDefinition , workflow_schema_url : &quot;./mediacloudai/standard/1.10/workflow-definition.schema.json&quot; Prometheus exporter Several metrics are defined to monitor step flow: number of workflows per identifier created in the last 24 hours execution time of worflows per identifier of ended worflow in the last 24 hours Metrics can be exported by: config :step_flow , StepFlow , enable_metrics : true # activate metrics Metric exports can be formatted: config :prometheus , StepFlow.Metrics.PrometheusExporter , format : :auto , ## or :protobuf, or :text Export endpoint can be optionally secured using HTTP Basic Authentication: config :prometheus , StepFlow.Metrics.PrometheusExporter , auth : { :basic , &quot;username&quot; , &quot;password&quot; } Metrics can be configured with config :step_flow , StepFlow.Metrics , scale : &quot;day&quot; , # &quot;year&quot;, &quot;month&quot;, &quot;week&quot;, &quot;day&quot;, &quot;hour&quot;, &quot;minute&quot;, &quot;second&quot;, &quot;millisecond&quot;, and &quot;microsecond&quot; delta : - 1","ref":"readme.html#configurations-to-start","title":"Step Flow - Configurations to start","type":"extras"}]